using System;
using System.Collections.Generic;
using System.Text;

namespace OHE.LCP.Admin.CourseCopying
{
    public class Constants
    {
        public static class SiteMapKeys
        {
            //Default
            public const String DefaultKey = "CourseCopying";
            public const String DefaultTitle = "Course Copying";
            public const String DefaultUrl = "~/CourseCopying/Default.aspx";
            public const Int32 DefaultIndex = 5;

            //Course Copy
            public const String CourseCopyKey = "CourseCopy";
            public const String CourseCopyTitle = "Copy Courses";
            public const String CourseCopyUrl = "~/CourseCopying/CourseCopy.aspx";
            public const Int32 CourseCopyIndex = 1;

            //Master Courses
            public const String MasterCoursesKey = "MasterCourses";
            public const String MasterCoursesTitle = "Manage Master Courses";
            public const String MasterCoursesUrl = "~/CourseCopying/MasterCourses.aspx";
            public const Int32 MasterCoursesIndex = 2;

            //Terms
            public const String TermsKey = "Terms";
            public const String TermsTitle = "Manage eCollege Terms";
            public const String TermsUrl = "~/CourseCopying/Terms.aspx";
            public const Int32 TermsIndex = 3;

            //Default Mapping
            public const String DefaultMappingKey = "DefaultMapping";
            public const String DefaultMappingTitle = "Default Mapping";
            public const String DefaultMappingUrl = "~/CourseCopying/DefaultMapping.aspx";
            public const Int32 DefaultMappingIndex = 4;

            //History
            public const String HistoryKey = "History";
            public const String HistoryTitle = "History";
            public const String HistoryUrl = "~/CourseCopying/History.aspx";
            public const Int32 HistoryIndex = 5;

            //New Sections
            public const String NewSectionsKey = "NewSections";
            public const String NewSectionsTitle = "New Sections";
            public const String NewSectionsUrl = "~/CourseCopying/NewSections.aspx";
            public const Int32 NewSectionsIndex = 6;
        }

        public static class URLs
        {
            public const string MasterCourses = "MasterCourses.aspx";
            public const string Completed = "Completed.aspx";
            public const string Terms = "Terms.aspx";
            public const string CourseCopy = "CourseCopy.aspx";
            public const string Confirm = "Confirm.aspx";
        }

        public static class SessionKeys
        {
            public const string Courses = "Courses";
            public const string SelectedECollegeTerm = "SelectedECollegeTerm";
            public const string SelectedTerm = "SelectedTerm";
            public const string SelectedSubTerm = "SelectedSubTerm";
            public const string SelectedSchool = "SelectedSchool";
            public const string CourseCode = "CourseCode";
            public const string OldIsActive = "OldIsActive";
            public const string MasterCourseDisplayCode = "MasterCourseDisplayCode";
            public const string MasterCourseTitle = "MasterCourseTitle";
            public const string MasterCourseWarningDisplayCode = "MasterCourseWarningDisplayCode";
            public const string MasterCourseWarningTitle = "MasterCourseWarningTitle";
            public const string NewCourses = "NewCourses";
        }

        public static class Permissions
        {
            public const string AllowCourseCopying = "AllowCourseCopying";
        }
    }
}
