using System;
using System.Collections.Generic;
using System.Text;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;

namespace OHE.LCP.Admin.CourseCopying.Interface
{
    public interface ICourseCopyService
    {
        #region Master Course Methods
        IList<MasterCourse> GetAllMasterCourses(bool getBannerCourses);
        IList<MasterCourse> GetAllActiveMasterCourses(bool getBannerCourses);
        MasterCourse GetMasterCourse(int MasterCourseID);
        void InsertMasterCourse(MasterCourse masterCourse);
        void UpdateMasterCourse(MasterCourse masterCourse);
        #endregion

        #region Source Node Methods
        IList<SourceNode> GetAllSourceNodes();
        #endregion

        #region ECollege Term Methods
        IList<ECollegeTerm> GetAllECollegeTerms();
        IList<ECollegeTerm> GetAllActiveECollegeTerms();
        ECollegeTerm GetECollegeTerm(int TermID);
        void InsertECollegeTerm(ECollegeTerm ecollegeTerm);
        void UpdateECollegeTerm(ECollegeTerm ecollegeTerm);
        #endregion

        #region Banner Course Methods
        IList<Course> GetAllBannerCourses();
        Course GetBannerCourse(string courseCode);
        void MapMasterCourseBannerCourse(int masterCourseID, string bannerCourseCode);
        IList<Course> GetBannerCoursesByTermSubTermSchool(string term, string subTerm, string schoolName);
        Course GetBannerCourse(string courseCode, string subTerm, string term);
        #endregion

        #region Banner Term Methods
        IList<Term> GetAllTerms();
        IList<SubTerm> GetSubTermsByTerm(string term);
        #endregion

        IList<School> GetSchools();

        string GetNextBatchNumber();
        IList<Batch> GetBatches();

        #region Copy History Methods
        void InsertCopyHistory(CopyHistory copyHistory);
        IList<CopyHistory> GetCopyHistoryByBatchNumber(string batchNumber);
        #endregion

        List<Course> GetNewSections();
    }
}
