﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.ObjectBuilder;
using Microsoft.Practices.CompositeWeb;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;

namespace OHE.LCP.Admin.CourseCopying.Views
{
    public class ConfirmPresenter : Presenter<IConfirm>
    {

        // NOTE: Uncomment the following code if you want ObjectBuilder to inject the module controller
        //
        private CourseCopyingController _controller;
        public ConfirmPresenter([CreateNew] CourseCopyingController controller)
        {
            _controller = controller;
        }

        public override void OnViewLoaded()
        {
        }

        public override void OnViewInitialized()
        {
            this.View.Courses = _controller.GetCoursesToBeCopied();
        }

        public string GetNextBatchNumber()
        {
            return _controller.GetNextBatchNumber();
        }

        public void InsertCopyHistory(CopyHistory copyHistory)
        {
            _controller.InsertCopyHistory(copyHistory);
        }

        public void OnBackClick()
        {
            _controller.OnConfirmBack();
        }

        public void OnConfirmClick()
        {
            _controller.ProcessCourseCopy();
        }
    }
}




