﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.ObjectBuilder;
using Microsoft.Practices.CompositeWeb;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;
using System.Web;
using System.Web.UI;
using OHE.LCP.Admin.CourseCopying.Resources;

namespace OHE.LCP.Admin.CourseCopying.Views
{
    public class CourseCopyPopUpPresenter : Presenter<ICourseCopyPopUp2>
    {

        private CourseCopyingController _controller;
        public CourseCopyPopUpPresenter([CreateNew] CourseCopyingController controller)
        {
            _controller = controller;
        }

        public override void OnViewLoaded()
        {
            //Get the proper banner course - this is used to show some of the course information at the top of the screen
            this.View.BannerCourse = _controller.GetBannerCourse(HttpContext.Current.Request.QueryString["courseCode"].ToString());

            this.View.MasterCourses = _controller.GetAllActiveMasterCourses(false);

            HttpContext.Current.Session[Constants.SessionKeys.CourseCode] = HttpContext.Current.Request.QueryString["courseCode"].ToString();
        }

        public override void OnViewInitialized()
        {
        }

        public void OnGetBannerCourse(string courseCode)
        {
            this.View.BannerCourse = _controller.GetBannerCourse(courseCode);
        }

        public MasterCourse GetMasterCourse(int masterCourseID)
        {
            return _controller.GetMasterCourse(masterCourseID);
        }

        public void OnSaveClick()
        {
            //Get the list of Courses out of Session.  
            List<Course> _courses = (List<Course>)HttpContext.Current.Session[Constants.SessionKeys.Courses];
            //Then find the correct course object and replace the Master_Course object with the selected one from here
            CourseByCourseCodeFinder _courseFinder = new CourseByCourseCodeFinder(HttpContext.Current.Session[Constants.SessionKeys.CourseCode].ToString());
            Course _course = _courses.Find(_courseFinder.Test);
            if (_course != null)
            {
                //Set the OverWriteMaster property to true
                _course.OverwriteMaster = true;
                //Get a MasterCourse object using the selected data key
                int rowIndex = this.View.CourseGrid.MasterTableView.ChildSelectedItems[0].ItemIndex;//adjust for header
                int courseId = Convert.ToInt32(this.View.CourseGrid.MasterTableView.DataKeyValues[rowIndex][this.View.CourseGrid.MasterTableView.DataKeyNames[0]]);
                _course.Master_Course = this.GetMasterCourse(courseId);
                //Then put the list of Courses back in Session.
                HttpContext.Current.Session[Constants.SessionKeys.Courses] = _courses;
            }
            //Close the window using javascript
            HttpContext.Current.Response.Write("<script language='javascript'>window.close();</script>");
        }
    }
}




