﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.ObjectBuilder;
using Microsoft.Practices.CompositeWeb;
using System.Web;
using System.Web.UI;

namespace OHE.LCP.Admin.CourseCopying.Views
{
    public class DefaultMappingPopUpPresenter : Presenter<IDefaultMappingPopUp>
    {

        private CourseCopyingController _controller;
        public DefaultMappingPopUpPresenter([CreateNew] CourseCopyingController controller)
        {
            _controller = controller;
        }

        public override void OnViewLoaded()
        {
            this.View.MasterCourses = _controller.GetAllActiveMasterCourses(false);
            //Get the banner course - this is used for displaying some of the course information at the top of the screen
            this.View.BannerCourse = _controller.GetBannerCourse(HttpContext.Current.Request.QueryString["id"]);
            HttpContext.Current.Session[Constants.SessionKeys.CourseCode] = HttpContext.Current.Request.QueryString["id"];
        }

        public override void OnViewInitialized()
        {
        }

        public void OnSaveClick(int masterCourseID)
        {
            //Map the master course to the banner course
            _controller.MapMasterCourseBannerCourse(masterCourseID, HttpContext.Current.Session[Constants.SessionKeys.CourseCode].ToString());
            //Close the window
            HttpContext.Current.Response.Write("<script language='javascript'>window.close();</script>");
        }
    }
}




