using System;
using System.Collections.Generic;
using System.Text;

namespace OHE.Admin.Security.Module
{
    public class Constants
    {
        public static class SiteMapKeys
        {
            //Security
            public const String SecurityKey = "Security";
            public const String SecurityTitle = "Security";
            public const String SecurityUrl = "~/Security/Default.aspx";
            public const Int32 SecurityIndex = 4;

            //Institution
            public const String InstitutionsKey = "InstitutionView";
            public const String InstitutionsTitle = "Institutions";
            public const String InstitutionsUrl = "~/Security/InstitutionList.aspx";
            public const Int32 InstitutionsIndex = 1;

            //Security Context
            public const String SecurityContextsKey = "SecurityContextView";
            public const String SecurityContextsTitle = "Security Contexts";
            public const String SecurityContextsUrl = "~/Security/SecurityContextList.aspx";
            public const Int32 SecurityContextsIndex = 2;

            //User
            public const String UsersKey = "UserView";
            public const String UsersTitle = "Users";
            public const String UsersUrl = "~/Security/UserSearch.aspx";
            public const Int32 UsersIndex = 3;

        }

        public static class URLS
        {
            public const String RoleList = "RoleList.aspx?securitycontextid={0}";
            public const String ActionList = "ActionList.aspx?securitycontextid={0}";
            public const String InstitutionList = "InstitutionList.aspx";
            public const String SecurityContextList = "SecurityContextList.aspx";
            public const String UserSearch = "UserSearch.aspx";
        }

        public static class Permissions
        {
            public const string AllowSecurityMaintenance = "AllowSecurityMaintenance";
            public const string AllowUserMaintenance = "AllowUserMaintenance";
            public const string AllowInstitutionMaintenance = "AllowInstitutionMaintenance";
            public const string AllowSecurityContextMaintenance = "AllowSecurityContextMaintenance";
            public const string CanEditSecurityIdentity = "CanEditSecurityIdentity";
        }
    }
}
