using System;
using System.Collections.Generic;
using System.Text;
using OHE.Security.DataTypes;

namespace OHE.Admin.Security.Module.Services
{
    public interface IAdministrationServiceAgent
    {
        void CreateSecurityContext(SecurityContext securityContext);
        List<SecurityContext> GetAllSecurityContexts();
        SecurityContext GetSecurityContext(int ID);
        void DeleteSecurityContext(SecurityContext securityContext);
        void UpdateSecurityContext(SecurityContext securityContext);
        void CreateInstitution(Institution institution);
        List<Institution> GetAllInstitutions();
        void DeleteInstitution(Institution institution);
        void UpdateInstitution(Institution institution);
        Institution GetInstitution(int ID);
        List<Action> GetAllActions(int securityContextID);
        void DeleteAction(Action action);
        void CreateAction(Action action);
        void UpdateAction(Action action);
        Action GetAction(Int32 ID);
        List<User> FindUsersBySearchCriteria(UserSearchCriteria criteria, int startRowIndex, int maximumRows, out int totalRecords);
    }
}
