﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.ObjectBuilder;
using Microsoft.Practices.CompositeWeb;
using OHE.Security.DataTypes;

namespace OHE.Admin.Security.Module.Views
{
    /// <summary>
    /// The presenter class for the Institution Listing page.
    /// </summary>
    public class InstitutionListPresenter : Presenter<IInstitutionListView>
    {

        private SecurityController _controller;

        /// <summary>
        /// Constructor.  Sets the reference to the controller
        /// </summary>
        /// <param name="controller">The controller</param>
        public InstitutionListPresenter([CreateNew] SecurityController controller)
        {
        	_controller = controller;
        }

        /// <summary>
        /// Sets the Intsitutions property to the list of institutions from the controller when the view is loaded.
        /// </summary>
        public override void OnViewLoaded()
        {
            this.View.Institutions = _controller.GetAllInstitutions();
        }

        /// <summary>
        /// Deletes the selected institution.
        /// </summary>
        /// <param name="institution">The institution to be deleted</param>
        public void OnInstitutionDeleted(Institution institution)
        {
            _controller.DeleteInstitution(institution);
        }
    }
}




