﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.ObjectBuilder;
using Microsoft.Practices.CompositeWeb;
using OHE.Admin.Security.Module;
using OHE.Security.DataTypes;

namespace OHE.Admin.Security.Module.Views
{
    /// <summary>
    /// The presenter for the user detail page.
    /// </summary>
    public class UserDetailsPresenter : Presenter<IUserDetailsView>
    {
        private SecurityController _controller;

        /// <summary>
        /// Constructor.  Sets the reference to the controller.
        /// </summary>
        /// <param name="controller">The controller for the presenter</param>
        public UserDetailsPresenter([CreateNew] SecurityController controller)
        {
        	_controller = controller;
        }

        /// <summary>
        /// 
        /// </summary>
        public override void OnViewInitialized()
        {
            User user = _controller.GetUser(View.ID);
            if (user != null)
            {
                this.View.User = user;
                this.View.Identities = user.Identities;
            }
        }

        /// <summary>
        /// Cancels an action
        /// </summary>
        public void OnCancel()
        {
            _controller.Redirect(Constants.URLS.UserSearch);
        }

    }
}




