using System;
using System.Collections.Generic;
using System.Text;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;

namespace OHE.LCP.Admin.CourseCopying.BusinessEntities
{
    public partial class Course
    {
        private MasterCourse _masterCourse;
        public MasterCourse Master_Course
        {
            get { return _masterCourse; }
            set { _masterCourse = value; }
        }

        private IList<Section> _sections = new List<Section>();
        public IList<Section> Sections
        {
            get { return _sections; }
            set { _sections = value; }
        }

        private IList<CopyHistory> _copyHistoryItems = new List<CopyHistory>();
        public IList<CopyHistory> CopyHistoryItems
        {
            get { return _copyHistoryItems; }
            set { _copyHistoryItems = value; }
        }

        public bool IsCopied
        {
            get { return (_copyHistoryItems.Count > 0); }
        }

        private bool _overwriteMaster = false;
        public bool OverwriteMaster
        {
            get { return _overwriteMaster; }
            set { _overwriteMaster = value; }
        }

        private bool _toBeCopied = false;
        public bool ToBeCopied
        {
            get { return _toBeCopied; }
            set { _toBeCopied = value; }
        }

        public MasterCourse SelectedMasterCourse
        {
            get 
            {
                MasterCourse _masterCourse = new MasterCourse();
                if (_overwriteMaster)
                {
                    _masterCourse = this._masterCourse;
                }
                else
                {
                    //Figure out which MasterCourse is the selected Master Course.  If all of the
                    //history used the default then return the default.  However, if the history
                    //used a different Master then return that one
                    bool _isDifferent = false;
                    foreach (CopyHistory _copyHistory in this._copyHistoryItems)
                    {
                        //Check to see if it is different than the default
                        if (this._masterCourse != null && _copyHistory.MasterCourseDisplayCode != this._masterCourse.CourseDisplayCode)
                        {
                            //It is different
                            _isDifferent = true;
                            _masterCourse = new MasterCourse(_copyHistory.MasterCourseDisplayCode, _copyHistory.MasterCourseTitle, _copyHistory.MasterCourseECollegeID, true, Convert.ToInt32(_copyHistory.MasterCourseID));
                            break;
                        }
                    }
                    if (!_isDifferent)
                    {
                        //Return the default
                        _masterCourse = this._masterCourse;
                    }
                }
                return _masterCourse;
            }
        }
    }
}
