﻿
----------------------------------------------------------------
-- [dbo].[CopyHistory] Table
--
IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'InsertCopyHistory')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[InsertCopyHistory] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[InsertCopyHistory]
    @bannerCourseCode nvarchar(255) = NULL,
	@bannerCourseTitle nvarchar(255) = NULL,
	@bannerCRN nvarchar(255) = NULL,
	@bannerGroupCode nvarchar(255) = NULL,
	@bannerNode nvarchar(255) = NULL,
	@bannerSchoolName nvarchar(255) = NULL,
	@bannerSectionID nvarchar(255) = NULL,
	@bannerSubTerm nvarchar(255) = NULL,
	@bannerSubTermDescription nvarchar(255) = NULL,
	@bannerTerm nvarchar(255) = NULL,
	@bannerTermDescription nvarchar(255) = NULL,
	@copierID nvarchar(50) = NULL,
	@copyHistoryID int OUT,
	@dateCopied datetime = NULL,
	@eCollegeTerm nvarchar(100) = NULL,
	@eCollegeTermECollegeID nvarchar(50) = NULL,
	@eCollegeTermID int = NULL,
	@masterCourseDisplayCode nvarchar(50) = NULL,
	@masterCourseECollegeID nvarchar(7) = NULL,
	@masterCourseID int = NULL,
	@masterCourseSourceNode nvarchar(50) = NULL,
	@masterCourseTitle nvarchar(100) = NULL
AS
BEGIN
	SET NOCOUNT ON
	
    INSERT INTO [dbo].[CopyHistory] ([BannerCourseCode], [BannerCourseTitle], [BannerCRN], [BannerGroupCode], [BannerNode], [BannerSchoolName], [BannerSectionID], [BannerSubTerm], [BannerSubTermDescription], [BannerTerm], [BannerTermDescription], [CopierID], [DateCopied], [ECollegeTerm], [ECollegeTermECollegeID], [ECollegeTermID], [MasterCourseDisplayCode], [MasterCourseECollegeID], [MasterCourseID], [MasterCourseSourceNode], [MasterCourseTitle])
	VALUES (@bannerCourseCode, @bannerCourseTitle, @bannerCRN, @bannerGroupCode, @bannerNode, @bannerSchoolName, @bannerSectionID, @bannerSubTerm, @bannerSubTermDescription, @bannerTerm, @bannerTermDescription, @copierID, @dateCopied, @eCollegeTerm, @eCollegeTermECollegeID, @eCollegeTermID, @masterCourseDisplayCode, @masterCourseECollegeID, @masterCourseID, @masterCourseSourceNode, @masterCourseTitle)
    SET @copyHistoryID = SCOPE_IDENTITY()
    
    SET NOCOUNT OFF
END    

GO

IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'UpdateCopyHistory')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[UpdateCopyHistory] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[UpdateCopyHistory]
    @bannerCourseCode nvarchar(255) = NULL,
	@bannerCourseTitle nvarchar(255) = NULL,
	@bannerCRN nvarchar(255) = NULL,
	@bannerGroupCode nvarchar(255) = NULL,
	@bannerNode nvarchar(255) = NULL,
	@bannerSchoolName nvarchar(255) = NULL,
	@bannerSectionID nvarchar(255) = NULL,
	@bannerSubTerm nvarchar(255) = NULL,
	@bannerSubTermDescription nvarchar(255) = NULL,
	@bannerTerm nvarchar(255) = NULL,
	@bannerTermDescription nvarchar(255) = NULL,
	@copierID nvarchar(50) = NULL,
	@copyHistoryID int,
	@dateCopied datetime = NULL,
	@eCollegeTerm nvarchar(100) = NULL,
	@eCollegeTermECollegeID nvarchar(50) = NULL,
	@eCollegeTermID int = NULL,
	@masterCourseDisplayCode nvarchar(50) = NULL,
	@masterCourseECollegeID nvarchar(7) = NULL,
	@masterCourseID int = NULL,
	@masterCourseSourceNode nvarchar(50) = NULL,
	@masterCourseTitle nvarchar(100) = NULL
AS
BEGIN

	--The [dbo].[CopyHistory] table doesn't have a timestamp column. Optimistic concurrency logic cannot be generated
	SET NOCOUNT ON

	UPDATE [dbo].[CopyHistory] 
	SET [BannerCourseCode] = @bannerCourseCode, [BannerCourseTitle] = @bannerCourseTitle, [BannerCRN] = @bannerCRN, [BannerGroupCode] = @bannerGroupCode, [BannerNode] = @bannerNode, [BannerSchoolName] = @bannerSchoolName, [BannerSectionID] = @bannerSectionID, [BannerSubTerm] = @bannerSubTerm, [BannerSubTermDescription] = @bannerSubTermDescription, [BannerTerm] = @bannerTerm, [BannerTermDescription] = @bannerTermDescription, [CopierID] = @copierID, [DateCopied] = @dateCopied, [ECollegeTerm] = @eCollegeTerm, [ECollegeTermECollegeID] = @eCollegeTermECollegeID, [ECollegeTermID] = @eCollegeTermID, [MasterCourseDisplayCode] = @masterCourseDisplayCode, [MasterCourseECollegeID] = @masterCourseECollegeID, [MasterCourseID] = @masterCourseID, [MasterCourseSourceNode] = @masterCourseSourceNode, [MasterCourseTitle] = @masterCourseTitle
	WHERE [CopyHistoryID]=@copyHistoryID

	SET NOCOUNT OFF
END

GO

IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'DeleteCopyHistory')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[DeleteCopyHistory] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[DeleteCopyHistory]
	 @copyHistoryID int
AS
BEGIN
	SET NOCOUNT ON
	
    DELETE FROM [dbo].[CopyHistory]
	WHERE [CopyHistoryID]=@copyHistoryID
    
    SET NOCOUNT OFF
END

GO

IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetAllFromCopyHistory')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetAllFromCopyHistory] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetAllFromCopyHistory]    
AS
BEGIN
	SET NOCOUNT ON
	
	SELECT
	[copyHistory].[BannerCourseCode] AS 'BannerCourseCode',
	[copyHistory].[BannerCourseTitle] AS 'BannerCourseTitle',
	[copyHistory].[BannerCRN] AS 'BannerCRN',
	[copyHistory].[BannerGroupCode] AS 'BannerGroupCode',
	[copyHistory].[BannerNode] AS 'BannerNode',
	[copyHistory].[BannerSchoolName] AS 'BannerSchoolName',
	[copyHistory].[BannerSectionID] AS 'BannerSectionID',
	[copyHistory].[BannerSubTerm] AS 'BannerSubTerm',
	[copyHistory].[BannerSubTermDescription] AS 'BannerSubTermDescription',
	[copyHistory].[BannerTerm] AS 'BannerTerm',
	[copyHistory].[BannerTermDescription] AS 'BannerTermDescription',
	[copyHistory].[CopierID] AS 'CopierID',
	[copyHistory].[CopyHistoryID] AS 'CopyHistoryID',
	[copyHistory].[DateCopied] AS 'DateCopied',
	[copyHistory].[ECollegeTerm] AS 'ECollegeTerm',
	[copyHistory].[ECollegeTermECollegeID] AS 'ECollegeTermECollegeID',
	[copyHistory].[ECollegeTermID] AS 'ECollegeTermID',
	[copyHistory].[MasterCourseDisplayCode] AS 'MasterCourseDisplayCode',
	[copyHistory].[MasterCourseECollegeID] AS 'MasterCourseECollegeID',
	[copyHistory].[MasterCourseID] AS 'MasterCourseID',
	[copyHistory].[MasterCourseSourceNode] AS 'MasterCourseSourceNode',
	[copyHistory].[MasterCourseTitle] AS 'MasterCourseTitle'
FROM [dbo].[CopyHistory] [copyHistory]

	SET NOCOUNT OFF
END

GO

IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetCopyHistoryByCopyHistoryID')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetCopyHistoryByCopyHistoryID] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetCopyHistoryByCopyHistoryID] 
	@copyHistoryID int
AS
BEGIN

	SET NOCOUNT ON
	
	SELECT
	[copyHistory].[BannerCourseCode] AS 'BannerCourseCode',
	[copyHistory].[BannerCourseTitle] AS 'BannerCourseTitle',
	[copyHistory].[BannerCRN] AS 'BannerCRN',
	[copyHistory].[BannerGroupCode] AS 'BannerGroupCode',
	[copyHistory].[BannerNode] AS 'BannerNode',
	[copyHistory].[BannerSchoolName] AS 'BannerSchoolName',
	[copyHistory].[BannerSectionID] AS 'BannerSectionID',
	[copyHistory].[BannerSubTerm] AS 'BannerSubTerm',
	[copyHistory].[BannerSubTermDescription] AS 'BannerSubTermDescription',
	[copyHistory].[BannerTerm] AS 'BannerTerm',
	[copyHistory].[BannerTermDescription] AS 'BannerTermDescription',
	[copyHistory].[CopierID] AS 'CopierID',
	[copyHistory].[CopyHistoryID] AS 'CopyHistoryID',
	[copyHistory].[DateCopied] AS 'DateCopied',
	[copyHistory].[ECollegeTerm] AS 'ECollegeTerm',
	[copyHistory].[ECollegeTermECollegeID] AS 'ECollegeTermECollegeID',
	[copyHistory].[ECollegeTermID] AS 'ECollegeTermID',
	[copyHistory].[MasterCourseDisplayCode] AS 'MasterCourseDisplayCode',
	[copyHistory].[MasterCourseECollegeID] AS 'MasterCourseECollegeID',
	[copyHistory].[MasterCourseID] AS 'MasterCourseID',
	[copyHistory].[MasterCourseSourceNode] AS 'MasterCourseSourceNode',
	[copyHistory].[MasterCourseTitle] AS 'MasterCourseTitle'
	FROM [dbo].[CopyHistory] [copyHistory]
	WHERE [CopyHistoryID]=@copyHistoryID

	SET NOCOUNT OFF
END

GO


