﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;

namespace OHE.LCP.Admin.CourseCopying.DataAccess
{
    /// <summary>
    /// Construct a ECollegeTerm object from a datareader.
    /// </summary>
    internal class GetAllActiveECollegeTermFactory : IDomainObjectFactory<ECollegeTerm>
    {
        public ECollegeTerm Construct(IDataReader reader)
        {
            ECollegeTerm eCollegeTerm = new ECollegeTerm();

            int courseStartDateIndex = reader.GetOrdinal("CourseStartDate");
            if (!reader.IsDBNull(courseStartDateIndex))
            {
                eCollegeTerm.CourseStartDate = reader.GetDateTime(courseStartDateIndex);
            }

            int termIDIndex = reader.GetOrdinal("TermID");
            if (!reader.IsDBNull(termIDIndex))
            {
                eCollegeTerm.TermID = reader.GetInt32(termIDIndex);

            }

            int isActiveIndex = reader.GetOrdinal("IsActive");
            if (!reader.IsDBNull(isActiveIndex))
            {
                eCollegeTerm.IsActive = reader.GetBoolean(isActiveIndex);

            }

            int eCollegeTermIndex = reader.GetOrdinal("eCollegeTerm");
            if (!reader.IsDBNull(eCollegeTermIndex))
            {
                eCollegeTerm.eCollegeTerm = reader.GetString(eCollegeTermIndex);

            }

            int eCollegeIDIndex = reader.GetOrdinal("eCollegeID");
            if (!reader.IsDBNull(eCollegeIDIndex))
            {
                eCollegeTerm.eCollegeID = reader.GetString(eCollegeIDIndex);

            }


            return eCollegeTerm;
        }
    }
}

