﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;

namespace OHE.LCP.Admin.CourseCopying.DataAccess
{
    /// <summary>
    /// Construct a Course object from a datareader.
    /// </summary>
    internal class GetAllFromCourseFactory : IDomainObjectFactory<Course>
    {
        public Course Construct(IDataReader reader)
        {
            Course course = new Course();

            int courseCodeIndex = reader.GetOrdinal("CourseCode");
            if (!reader.IsDBNull(courseCodeIndex))
            {
                course.CourseCode = reader.GetString(courseCodeIndex);
                //if (_withSections)
                //{
                //    //Get the sections for this course
                //    SectionRepository _sectionRepository = new SectionRepository("BannerConnection");
                //    course.Sections = _sectionRepository.GetSectionByCourseCode(course.CourseCode);

                //    foreach (Section _section in course.Sections)
                //    {
                //        _section.SectionCourse = course;
                //    }
                //}
            }

            int courseTitleIndex = reader.GetOrdinal("CourseTitle");
            if (!reader.IsDBNull(courseTitleIndex))
            {
                course.CourseTitle = reader.GetString(courseTitleIndex);

            }

            return course;
        }
    }
}

