﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;

namespace OHE.LCP.Admin.CourseCopying.DataAccess
{
    /// <summary>
    /// Construct a MasterCourse object from a datareader.
    /// </summary>
    internal class GetAllFromMasterCourseFactory : IDomainObjectFactory<MasterCourse>
    {
        public MasterCourse Construct(IDataReader reader)
        {
            MasterCourse masterCourse = new MasterCourse();

            int courseDisplayCodeIndex = reader.GetOrdinal("CourseDisplayCode");
            if (!reader.IsDBNull(courseDisplayCodeIndex))
            {
                masterCourse.CourseDisplayCode = reader.GetString(courseDisplayCodeIndex);

            }

            int courseTitleIndex = reader.GetOrdinal("CourseTitle");
            if (!reader.IsDBNull(courseTitleIndex))
            {
                masterCourse.CourseTitle = reader.GetString(courseTitleIndex);

            }

            int eCollegeIDIndex = reader.GetOrdinal("eCollegeID");
            if (!reader.IsDBNull(eCollegeIDIndex))
            {
                masterCourse.eCollegeID = reader.GetString(eCollegeIDIndex);

            }

            int isActiveIndex = reader.GetOrdinal("IsActive");
            if (!reader.IsDBNull(isActiveIndex))
            {
                masterCourse.IsActive = reader.GetBoolean(isActiveIndex);

            }

            int masterCourseIDIndex = reader.GetOrdinal("MasterCourseID");
            if (!reader.IsDBNull(masterCourseIDIndex))
            {
                masterCourse.MasterCourseID = reader.GetInt32(masterCourseIDIndex);

            }

            //Get all of the Banner Courses
            //BannerCourseStubRepository _bannerCourseStubRepository = new BannerCourseStubRepository("CourseCopyConn");
            //CourseRepository _courseRepository = new CourseRepository("BannerConnection");
            //IList<BannerCourseStub> _bannerCourseStubs = _bannerCourseStubRepository.GetMasterCourseBannerCourseByMasterCourseID(reader.GetInt32(masterCourseIDIndex));
            //foreach (BannerCourseStub _bannerCourseStub in _bannerCourseStubs)
            //{
            //    Course _course = _courseRepository.GetCourseByCourseCode(_bannerCourseStub.BannerCourseCode);
            //    masterCourse.BannerCourses.Add(_course);
            //}

            //Get the source node
            //int sourceNodeIndex = reader.GetOrdinal("SourceNode");
            //SourceNodeRepository _sourceNodeRepository = new SourceNodeRepository("CourseCopyConn");
            //SourceNode _sourceNode = _sourceNodeRepository.GetSourceNodeByNode(reader.GetString(sourceNodeIndex));
            //masterCourse.MasterCourseSourceNode = _sourceNode;

            return masterCourse;
        }
    }
}

