﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;

namespace OHE.LCP.Admin.CourseCopying.DataAccess
{
    /// <summary>
    /// Construct a Section object from a datareader.
    /// </summary>
    internal class GetAllFromSectionFactory : IDomainObjectFactory<Section>
    {
        public Section Construct(IDataReader reader)
        {
            Section section = new Section();

            int cRNIndex = reader.GetOrdinal("CRN");
            if (!reader.IsDBNull(cRNIndex))
            {
                section.CRN = reader.GetString(cRNIndex);

            }

            int groupCodeIndex = reader.GetOrdinal("GroupCode");
            if (!reader.IsDBNull(groupCodeIndex))
            {
                section.GroupCode = reader.GetString(groupCodeIndex);

            }

            int schoolNameIndex = reader.GetOrdinal("SchoolName");
            if (!reader.IsDBNull(schoolNameIndex))
            {
                section.SchoolName = reader.GetString(schoolNameIndex);

            }

            int sectionIDIndex = reader.GetOrdinal("SectionID");
            if (!reader.IsDBNull(sectionIDIndex))
            {
                section.SectionID = reader.GetString(sectionIDIndex);

            }

            int instructorFirstNameIndex = reader.GetOrdinal("InstructorFirstName");
            if (!reader.IsDBNull(instructorFirstNameIndex))
            {
                section.InstructorFirstName = reader.GetString(instructorFirstNameIndex);
            }

            int instructorLastNameIndex = reader.GetOrdinal("InstructorLastName");
            if (!reader.IsDBNull(instructorLastNameIndex))
            {
                section.InstructorLastName = reader.GetString(instructorLastNameIndex);
            }

            int instructorMiddleInitialIndex = reader.GetOrdinal("InstructorMiddleInitial");
            if (!reader.IsDBNull(instructorMiddleInitialIndex))
            {
                section.InstructorMiddleInitial = reader.GetString(instructorMiddleInitialIndex);
            }

            int courseStartDateIndex = reader.GetOrdinal("CourseStartDate");
            if (!reader.IsDBNull(courseStartDateIndex))
            {
                section.CourseStartDate = reader.GetDateTime(courseStartDateIndex);
            }

            int sectionCodeIndex = reader.GetOrdinal("SectionCode");
            if (!reader.IsDBNull(sectionCodeIndex))
            {
                section.SectionCode = reader.GetString(sectionCodeIndex);
            }

            int nodeIndex = reader.GetOrdinal("Node");
            if (!reader.IsDBNull(nodeIndex))
            {
                section.SectionNode = new SourceNode(reader.GetString(nodeIndex));
            }

            //Get the course for this section
            //int courseCodeIndex = reader.GetOrdinal("CourseCode");
            //if (!reader.IsDBNull(courseCodeIndex))
            //{
            //    CourseRepository _courseRepository = new CourseRepository("BannerConnection");
            //    Course _course = _courseRepository.GetCourseByCourseCode(reader.GetString(courseCodeIndex));
            //    section.SectionCourse = _course;
            //}

            int courseCodeIndex = reader.GetOrdinal("CourseCode");
            if (!reader.IsDBNull(courseCodeIndex))
            {
                section.CourseCode = reader.GetString(courseCodeIndex);
            }

            //Get the Term
            int termIndex = reader.GetOrdinal("Term");
            if (!reader.IsDBNull(termIndex))
            {
                //TermRepository _termRepository = new TermRepository("BannerConnection");
                //Term _term = _termRepository.GetTermByTerm(reader.GetString(termIndex));
                //section.SectionTerm = _term;
                section.TermString = reader.GetString(termIndex);
            }

            //Get the SubTerm
            int subTermIndex = reader.GetOrdinal("SubTerm");
            if (!reader.IsDBNull(subTermIndex))
            {
                //SubTermRepository _subTermRepository = new SubTermRepository("BannerConnection");
                //SubTerm _subTerm = _subTermRepository.GetSubTermBySubTerm(reader.GetString(subTermIndex));
                //section.SectionSubTerm = _subTerm;
                section.SubTermString = reader.GetString(subTermIndex);
            }

            return section;
        }
    }
}

