﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;

namespace OHE.LCP.Admin.CourseCopying.DataAccess
{
    /// <summary>
    /// Construct a SubTerm object from a datareader.
    /// </summary>
    internal class GetAllFromSubTermFactory : IDomainObjectFactory<SubTerm>
    {
        public SubTerm Construct(IDataReader reader)
        {
			SubTerm subTerm = new SubTerm();
			
			int subTermDescriptionIndex = reader.GetOrdinal("SubTermDescription"); 
            if(!reader.IsDBNull(subTermDescriptionIndex))
            {
				subTerm.SubTermDescription= reader.GetString(subTermDescriptionIndex);

			}

			int subTermNameIndex = reader.GetOrdinal("SubTerm"); 
            if(!reader.IsDBNull(subTermNameIndex))
            {
				subTerm.SubTermName= reader.GetString(subTermNameIndex);

			}

           
			return subTerm; 
        }
    }
}

