using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Data;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;
using OHE.LCP.Admin.CourseCopying.DataAccess.Generic;
using System.Globalization;

namespace OHE.LCP.Admin.CourseCopying.DataAccess
{
    internal class GetCopyHistoryByBatchNumberSelectionFactory : ISelectionFactory<System.String>
    {
        /// <summary>
        /// Creates the GetCopyHistoryByBatchNumberSelectionFactory to build a select statement for
        /// the given System.String.
        /// </summary>
        /// <param name="System.String">System.String to select from the database.</param>      
        public GetCopyHistoryByBatchNumberSelectionFactory()
        {
        }

        #region ISelectionFactory<System.String> Members
        public DbCommand ConstructSelectCommand(Database db, System.String batchNumber)
        {

            DbCommand command = db.GetStoredProcCommand("dbo.GetCopyHistoryByBatch");
            db.AddInParameter(command, "BatchNumber", DbType.String, batchNumber);
            return command;
        }
        #endregion

        #region IDbToBusinessEntityNameMapper Members
        /// <summary>
        /// Maps a field name in the database (usually a parameter name for a stored proc)
        /// to the corresponding business entity property name.
        /// </summary>
        /// <remarks>This method is intended for error message handling, not for reflection.</remarks>
        /// <param name="dbParameter">Name of field/parameter that the database knows about.</param>
        /// <returns>Corresponding business entity field name.</returns>
        public string MapDbParameterToBusinessEntityProperty(string dbParameter)
        {
            switch (dbParameter)
            {
                case "BatchNumber":
                    return "BatchNumber";
                default:
                    throw new ArgumentException(string.Format(CultureInfo.CurrentCulture, GenericResources.InvalidParameterName), dbParameter);
            }
        }
        #endregion
    }
}
