﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;

namespace OHE.LCP.Admin.CourseCopying.DataAccess
{
    /// <summary>
    /// Construct a CopyHistory object from a datareader.
    /// </summary>
    internal class GetCopyHistoryByCopyHistoryIDFactory : IDomainObjectFactory<CopyHistory>
    {
        public CopyHistory Construct(IDataReader reader)
        {
            CopyHistory copyHistory = new CopyHistory();

            int handledManuallyIndex = reader.GetOrdinal("HandledManually");
            if (!reader.IsDBNull(handledManuallyIndex))
            {
                copyHistory.HandledManually = reader.GetBoolean(handledManuallyIndex);
            }

            int bannerCourseStartDateIndex = reader.GetOrdinal("BannerCourseStartDate");
            if (!reader.IsDBNull(bannerCourseStartDateIndex))
            {
                copyHistory.BannerCourseStartDate = reader.GetDateTime(bannerCourseStartDateIndex);
            }

            int bannerSectionCodeIndex = reader.GetOrdinal("BannerSectionCode");
            if (!reader.IsDBNull(bannerSectionCodeIndex))
            {
                copyHistory.BannerSectionCode = reader.GetString(bannerSectionCodeIndex);
            }

            int instructorFirstNameIndex = reader.GetOrdinal("InstructorFirstName");
            if (!reader.IsDBNull(instructorFirstNameIndex))
            {
                copyHistory.InstructorFirstName = reader.GetString(instructorFirstNameIndex);
            }

            int instructorMiddleInitialIndex = reader.GetOrdinal("InstructorMiddleInitial");
            if (!reader.IsDBNull(instructorMiddleInitialIndex))
            {
                copyHistory.InstructorMiddleInitial = reader.GetString(instructorMiddleInitialIndex);
            }
            int instructorLastNameIndex = reader.GetOrdinal("InstructorLastName");
            if (!reader.IsDBNull(instructorLastNameIndex))
            {
                copyHistory.InstructorLastName = reader.GetString(instructorLastNameIndex);
            }
            int masterCourseTitleIndex = reader.GetOrdinal("MasterCourseTitle");
            if (!reader.IsDBNull(masterCourseTitleIndex))
            {
                copyHistory.MasterCourseTitle = reader.GetString(masterCourseTitleIndex);

            }

            int masterCourseSourceNodeIndex = reader.GetOrdinal("MasterCourseSourceNode");
            if (!reader.IsDBNull(masterCourseSourceNodeIndex))
            {
                copyHistory.MasterCourseSourceNode = reader.GetString(masterCourseSourceNodeIndex);

            }

            int masterCourseIDIndex = reader.GetOrdinal("MasterCourseID");
            if (!reader.IsDBNull(masterCourseIDIndex))
            {
                if (!reader.IsDBNull(masterCourseIDIndex))
                {
                    copyHistory.MasterCourseID = reader.GetInt32(masterCourseIDIndex);
                }

            }

            int masterCourseECollegeIDIndex = reader.GetOrdinal("MasterCourseECollegeID");
            if (!reader.IsDBNull(masterCourseECollegeIDIndex))
            {
                copyHistory.MasterCourseECollegeID = reader.GetString(masterCourseECollegeIDIndex);

            }

            int masterCourseDisplayCodeIndex = reader.GetOrdinal("MasterCourseDisplayCode");
            if (!reader.IsDBNull(masterCourseDisplayCodeIndex))
            {
                copyHistory.MasterCourseDisplayCode = reader.GetString(masterCourseDisplayCodeIndex);

            }

            int eCollegeTermIDIndex = reader.GetOrdinal("ECollegeTermID");
            if (!reader.IsDBNull(eCollegeTermIDIndex))
            {
                if (!reader.IsDBNull(eCollegeTermIDIndex))
                {
                    copyHistory.ECollegeTermID = reader.GetInt32(eCollegeTermIDIndex);
                }

            }

            int eCollegeTermECollegeIDIndex = reader.GetOrdinal("ECollegeTermECollegeID");
            if (!reader.IsDBNull(eCollegeTermECollegeIDIndex))
            {
                copyHistory.ECollegeTermECollegeID = reader.GetString(eCollegeTermECollegeIDIndex);

            }

            int eCollegeTermIndex = reader.GetOrdinal("ECollegeTerm");
            if (!reader.IsDBNull(eCollegeTermIndex))
            {
                copyHistory.ECollegeTerm = reader.GetString(eCollegeTermIndex);

            }

            int dateCopiedIndex = reader.GetOrdinal("DateCopied");
            if (!reader.IsDBNull(dateCopiedIndex))
            {
                if (!reader.IsDBNull(dateCopiedIndex))
                {
                    copyHistory.DateCopied = reader.GetDateTime(dateCopiedIndex);
                }

            }

            int copyHistoryIDIndex = reader.GetOrdinal("CopyHistoryID");
            if (!reader.IsDBNull(copyHistoryIDIndex))
            {
                copyHistory.CopyHistoryID = reader.GetInt32(copyHistoryIDIndex);

            }

            int copierIDIndex = reader.GetOrdinal("CopierID");
            if (!reader.IsDBNull(copierIDIndex))
            {
                copyHistory.CopierID = reader.GetString(copierIDIndex);

            }

            int bannerTermDescriptionIndex = reader.GetOrdinal("BannerTermDescription");
            if (!reader.IsDBNull(bannerTermDescriptionIndex))
            {
                copyHistory.BannerTermDescription = reader.GetString(bannerTermDescriptionIndex);

            }

            int bannerTermIndex = reader.GetOrdinal("BannerTerm");
            if (!reader.IsDBNull(bannerTermIndex))
            {
                copyHistory.BannerTerm = reader.GetString(bannerTermIndex);

            }

            int bannerSubTermDescriptionIndex = reader.GetOrdinal("BannerSubTermDescription");
            if (!reader.IsDBNull(bannerSubTermDescriptionIndex))
            {
                copyHistory.BannerSubTermDescription = reader.GetString(bannerSubTermDescriptionIndex);

            }

            int bannerSubTermIndex = reader.GetOrdinal("BannerSubTerm");
            if (!reader.IsDBNull(bannerSubTermIndex))
            {
                copyHistory.BannerSubTerm = reader.GetString(bannerSubTermIndex);

            }

            int bannerSectionIDIndex = reader.GetOrdinal("BannerSectionID");
            if (!reader.IsDBNull(bannerSectionIDIndex))
            {
                copyHistory.BannerSectionID = reader.GetString(bannerSectionIDIndex);

            }

            int bannerSchoolNameIndex = reader.GetOrdinal("BannerSchoolName");
            if (!reader.IsDBNull(bannerSchoolNameIndex))
            {
                copyHistory.BannerSchoolName = reader.GetString(bannerSchoolNameIndex);

            }

            int bannerNodeIndex = reader.GetOrdinal("BannerNode");
            if (!reader.IsDBNull(bannerNodeIndex))
            {
                copyHistory.BannerNode = reader.GetString(bannerNodeIndex);

            }

            int bannerGroupCodeIndex = reader.GetOrdinal("BannerGroupCode");
            if (!reader.IsDBNull(bannerGroupCodeIndex))
            {
                copyHistory.BannerGroupCode = reader.GetString(bannerGroupCodeIndex);

            }

            int bannerCRNIndex = reader.GetOrdinal("BannerCRN");
            if (!reader.IsDBNull(bannerCRNIndex))
            {
                copyHistory.BannerCRN = reader.GetString(bannerCRNIndex);

            }

            int bannerCourseTitleIndex = reader.GetOrdinal("BannerCourseTitle");
            if (!reader.IsDBNull(bannerCourseTitleIndex))
            {
                copyHistory.BannerCourseTitle = reader.GetString(bannerCourseTitleIndex);

            }

            int bannerCourseCodeIndex = reader.GetOrdinal("BannerCourseCode");
            if (!reader.IsDBNull(bannerCourseCodeIndex))
            {
                copyHistory.BannerCourseCode = reader.GetString(bannerCourseCodeIndex);

            }

            int batchNumberIndex = reader.GetOrdinal("BatchNumber");
            if (!reader.IsDBNull(batchNumberIndex))
            {
                copyHistory.BatchNumber = reader.GetString(batchNumberIndex);

            }

            return copyHistory;
        }
    }
}

