﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Data;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;
using OHE.LCP.Admin.CourseCopying.DataAccess.Generic;
using System.Globalization;

namespace OHE.LCP.Admin.CourseCopying.DataAccess
{
    /// <summary>
    /// This class is responsible for turning a selection criteria
    /// into a select statement and database query parameters.
    /// </summary>
    internal class GetCopyHistoryByCourseTermSubTermSelectionFactory : ISelectionFactory<GetCopyHistoryByCourseTermSubTermIdentity>
    {
        /// <summary>
        /// Creates the GetCopyHistoryByCourseTermSubTermSelectionFactory to build a select statement for
        /// the given GetCopyHistoryByCourseTermSubTermIdentity.
        /// </summary>
        /// <param name="GetCopyHistoryByCourseTermSubTermIdentity">GetCopyHistoryByCourseTermSubTermIdentity to select from the database.</param>      
        public GetCopyHistoryByCourseTermSubTermSelectionFactory()
        {
        }

        #region ISelectionFactory<GetCopyHistoryByCourseTermSubTermIdentity> Members
        public DbCommand ConstructSelectCommand(Database db, GetCopyHistoryByCourseTermSubTermIdentity getCopyHistoryByCourseTermSubTermIdentity)
        {

            DbCommand command = db.GetStoredProcCommand("dbo.GetCopyHistoryByCourseTermSubTerm");
            db.AddInParameter(command, "CourseCode", DbType.String, getCopyHistoryByCourseTermSubTermIdentity.CourseCode);
            db.AddInParameter(command, "SubTerm", DbType.String, getCopyHistoryByCourseTermSubTermIdentity.SubTerm);
            db.AddInParameter(command, "Term", DbType.String, getCopyHistoryByCourseTermSubTermIdentity.Term);
            return command;
        }
        #endregion

        #region IDbToBusinessEntityNameMapper Members
        /// <summary>
        /// Maps a field name in the database (usually a parameter name for a stored proc)
        /// to the corresponding business entity property name.
        /// </summary>
        /// <remarks>This method is intended for error message handling, not for reflection.</remarks>
        /// <param name="dbParameter">Name of field/parameter that the database knows about.</param>
        /// <returns>Corresponding business entity field name.</returns>
        public string MapDbParameterToBusinessEntityProperty(string dbParameter)
        {
            switch (dbParameter)
            {
                case "CourseCode":
                    return "CourseCode";
                case "SubTerm":
                    return "SubTerm";
                case "Term":
                    return "Term";
                default:
                    throw new ArgumentException(string.Format(CultureInfo.CurrentCulture, GenericResources.InvalidParameterName), dbParameter);
            }
        }
        #endregion
    }
}

