using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Data;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;
using OHE.LCP.Admin.CourseCopying.DataAccess.Generic;
using System.Globalization;
using System.Data.OracleClient;

namespace OHE.LCP.Admin.CourseCopying.DataAccess
{
    internal class GetCourseByTermSubTermSchoolSelectionFactory : ISelectionFactory<GetCourseByTermSubTermSchoolIdentity>
    {
        public GetCourseByTermSubTermSchoolSelectionFactory()
        { 
        }

        public DbCommand ConstructSelectCommand(Database db, GetCourseByTermSubTermSchoolIdentity getCourseByTermSubTermSchoolIdentity)
        {
            //DbCommand command = db.GetStoredProcCommand("GetCourseByTermSubTermSchool");
            //db.AddInParameter(command, "Term", DbType.String, getCourseByTermSubTermSchoolIdentity.Term);
            //db.AddInParameter(command, "SubTerm", DbType.String, getCourseByTermSubTermSchoolIdentity.SubTerm);
            //db.AddInParameter(command, "SchoolName", DbType.String, getCourseByTermSubTermSchoolIdentity.SchoolName);
            //return command;

            DbCommand command = db.GetStoredProcCommand("LAUREATE.laur_course_copy.GetCourseByTermSubTermSchool");
            db.AddInParameter(command, "str_term", DbType.String, getCourseByTermSubTermSchoolIdentity.Term);
            db.AddInParameter(command, "str_subterm", DbType.String, getCourseByTermSubTermSchoolIdentity.SubTerm);
            db.AddInParameter(command, "str_school", DbType.String, getCourseByTermSubTermSchoolIdentity.SchoolName);
            OracleParameter refCursor1 = new OracleParameter();
            refCursor1.OracleType = OracleType.Cursor;
            refCursor1.ParameterName = "course_ref";
            refCursor1.Direction = ParameterDirection.Output;
            command.Parameters.Add(refCursor1);
            return command;

        }

        public string MapDbParameterToBusinessEntityProperty(string dbParameter)
        {
            switch (dbParameter)
            {
                case "Term":
                    return "Term";
                case "SubTerm":
                    return "SubTerm";
                case "SchoolName":
                    return "SchoolName";
                default:
                    throw new ArgumentException(string.Format(CultureInfo.CurrentCulture, GenericResources.InvalidParameterName), dbParameter);
            }
        } 

    }
}
