﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;

namespace OHE.LCP.Admin.CourseCopying.DataAccess
{
    /// <summary>
    /// Construct a BannerCourseStub object from a datareader.
    /// </summary>
    internal class GetMasterCourseBannerCourseByMasterCourseIDFactory : IDomainObjectFactory<BannerCourseStub>
    {
        public BannerCourseStub Construct(IDataReader reader)
        {
            BannerCourseStub bannerCourseStub = new BannerCourseStub();

            int masterCourseIDIndex = reader.GetOrdinal("MasterCourseID");
            if (!reader.IsDBNull(masterCourseIDIndex))
            {
                bannerCourseStub.MasterCourseID = reader.GetInt32(masterCourseIDIndex);

            }

            int bannerCourseCodeIndex = reader.GetOrdinal("BannerCourseCode");
            if (!reader.IsDBNull(bannerCourseCodeIndex))
            {
                bannerCourseStub.BannerCourseCode = reader.GetString(bannerCourseCodeIndex);

            }


            return bannerCourseStub;
        }
    }
}

