﻿

----------------------------------------------------------------
-- [dbo].[Course] Table
--
IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetAllFromCourse')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetAllFromCourse] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetAllFromCourse]    
AS
BEGIN
	SET NOCOUNT ON
	
	SELECT
	[course].[CourseCode] AS 'CourseCode',
	[course].[CourseTitle] AS 'CourseTitle'
FROM [dbo].[Course] [course]

	SET NOCOUNT OFF
END

GO

IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetCourseByCourseCode')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetCourseByCourseCode] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetCourseByCourseCode] 
	@courseCode nvarchar(255)
AS
BEGIN

	SET NOCOUNT ON
	
	SELECT
	[course].[CourseCode] AS 'CourseCode',
	[course].[CourseTitle] AS 'CourseTitle'
	FROM [dbo].[Course] [course]
	WHERE [CourseCode]=@courseCode

	SET NOCOUNT OFF
END

GO

----------------------------------------------------------------
-- [dbo].[Section] Table
--
IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetAllFromSection')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetAllFromSection] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetAllFromSection]    
AS
BEGIN
	SET NOCOUNT ON
	
	SELECT
	[section].[CourseCode] AS 'CourseCode',
	[section].[CRN] AS 'CRN',
	[section].[GroupCode] AS 'GroupCode',
	[section].[Node] AS 'Node',
	[section].[SchoolName] AS 'SchoolName',
	[section].[SectionID] AS 'SectionID',
	[section].[SubTerm] AS 'SubTerm',
	[section].[Term] AS 'Term'
FROM [dbo].[Section] [section]

	SET NOCOUNT OFF
END

GO

IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetSectionBySectionID')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetSectionBySectionID] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetSectionBySectionID] 
	@sectionID nvarchar(255)
AS
BEGIN

	SET NOCOUNT ON
	
	SELECT
	[section].[CourseCode] AS 'CourseCode',
	[section].[CRN] AS 'CRN',
	[section].[GroupCode] AS 'GroupCode',
	[section].[Node] AS 'Node',
	[section].[SchoolName] AS 'SchoolName',
	[section].[SectionID] AS 'SectionID',
	[section].[SubTerm] AS 'SubTerm',
	[section].[Term] AS 'Term'
	FROM [dbo].[Section] [section]
	WHERE [SectionID]=@sectionID

	SET NOCOUNT OFF
END

GO

----------------------------------------------------------------
-- [dbo].[SourceNode] Table
--
IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetAllFromSourceNode')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetAllFromSourceNode] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetAllFromSourceNode]    
AS
BEGIN
	SET NOCOUNT ON
	
	SELECT
	[sourceNode].[Node] AS 'Node'
FROM [dbo].[SourceNode] [sourceNode]

	SET NOCOUNT OFF
END

GO

IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetSourceNodeByNode')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetSourceNodeByNode] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetSourceNodeByNode] 
	@node nvarchar(255)
AS
BEGIN

	SET NOCOUNT ON
	
	SELECT
	[sourceNode].[Node] AS 'Node'
	FROM [dbo].[SourceNode] [sourceNode]
	WHERE [Node]=@node

	SET NOCOUNT OFF
END

GO

----------------------------------------------------------------
-- [dbo].[SubTerm] Table
--
IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetAllFromSubTerm')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetAllFromSubTerm] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetAllFromSubTerm]    
AS
BEGIN
	SET NOCOUNT ON
	
	SELECT
	[subTerm].[SubTerm] AS 'SubTerm',
	[subTerm].[SubTermDescription] AS 'SubTermDescription'
FROM [dbo].[SubTerm] [subTerm]

	SET NOCOUNT OFF
END

GO

IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetSubTermBySubTerm')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetSubTermBySubTerm] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetSubTermBySubTerm] 
	@subTerm nvarchar(255)
AS
BEGIN

	SET NOCOUNT ON
	
	SELECT
	[subTerm].[SubTerm] AS 'SubTerm',
	[subTerm].[SubTermDescription] AS 'SubTermDescription'
	FROM [dbo].[SubTerm] [subTerm]
	WHERE [SubTerm]=@subTerm

	SET NOCOUNT OFF
END

GO

----------------------------------------------------------------
-- [dbo].[Term] Table
--
IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetAllFromTerm')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetAllFromTerm] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetAllFromTerm]    
AS
BEGIN
	SET NOCOUNT ON
	
	SELECT
	[term].[Term] AS 'Term',
	[term].[TermDescription] AS 'TermDescription'
FROM [dbo].[Term] [term]

	SET NOCOUNT OFF
END

GO

IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetTermByTerm')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetTermByTerm] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetTermByTerm] 
	@term nvarchar(255)
AS
BEGIN

	SET NOCOUNT ON
	
	SELECT
	[term].[Term] AS 'Term',
	[term].[TermDescription] AS 'TermDescription'
	FROM [dbo].[Term] [term]
	WHERE [Term]=@term

	SET NOCOUNT OFF
END

GO


