﻿

----------------------------------------------------------------
-- [dbo].[DefaultMapping] Table
--
IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'InsertDefaultMapping')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[InsertDefaultMapping] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[InsertDefaultMapping]
    @cOURSE_CODE nvarchar(255),
	@masterCourseID int
AS
BEGIN
	SET NOCOUNT ON
	
    INSERT INTO [dbo].[DefaultMapping] ([COURSE_CODE], [MasterCourseID])
	VALUES (@cOURSE_CODE, @masterCourseID)
        
    SET NOCOUNT OFF
END    

GO

IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'UpdateDefaultMapping')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[UpdateDefaultMapping] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[UpdateDefaultMapping]
    @cOURSE_CODE nvarchar(255),
	@masterCourseID int
AS
BEGIN

	--The [dbo].[DefaultMapping] table doesn't have a timestamp column. Optimistic concurrency logic cannot be generated
	SET NOCOUNT ON

	UPDATE [dbo].[DefaultMapping] 
	SET [MasterCourseID] = @masterCourseID
	WHERE [COURSE_CODE]=@cOURSE_CODE

	SET NOCOUNT OFF
END

GO

IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetDefaultMappingByCOURSE_CODE')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetDefaultMappingByCOURSE_CODE] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetDefaultMappingByCOURSE_CODE] 
	@cOURSE_CODE nvarchar(255)
AS
BEGIN

	SET NOCOUNT ON
	
	SELECT
	[defaultMapping].[COURSE_CODE] AS 'COURSE_CODE',
	[defaultMapping].[MasterCourseID] AS 'MasterCourseID'
	FROM [dbo].[DefaultMapping] [defaultMapping]
	WHERE [COURSE_CODE]=@cOURSE_CODE

	SET NOCOUNT OFF
END

GO


