﻿
----------------------------------------------------------------
-- [dbo].[ECollegeTerm] Table
--
IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'InsertECollegeTerm')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[InsertECollegeTerm] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[InsertECollegeTerm]
    @eCollegeID nvarchar(50),
	@eCollegeTerm nvarchar(100),
	@isActive bit,
	@termID int OUT
AS
BEGIN
	SET NOCOUNT ON
	
    INSERT INTO [dbo].[ECollegeTerm] ([eCollegeID], [eCollegeTerm], [IsActive])
	VALUES (@eCollegeID, @eCollegeTerm, @isActive)
    SET @termID = SCOPE_IDENTITY()
    
    SET NOCOUNT OFF
END    

GO

IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'UpdateECollegeTerm')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[UpdateECollegeTerm] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[UpdateECollegeTerm]
    @eCollegeID nvarchar(50),
	@eCollegeTerm nvarchar(100),
	@isActive bit,
	@termID int
AS
BEGIN

	--The [dbo].[ECollegeTerm] table doesn't have a timestamp column. Optimistic concurrency logic cannot be generated
	SET NOCOUNT ON

	UPDATE [dbo].[ECollegeTerm] 
	SET [eCollegeID] = @eCollegeID, [eCollegeTerm] = @eCollegeTerm, [IsActive] = @isActive
	WHERE [TermID]=@termID


	SET NOCOUNT OFF
END

GO

IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetAllFromECollegeTerm')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetAllFromECollegeTerm] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetAllFromECollegeTerm]    
AS
BEGIN
	SET NOCOUNT ON
	
	SELECT
	[eCollegeTerm].[eCollegeID] AS 'eCollegeID',
	[eCollegeTerm].[eCollegeTerm] AS 'eCollegeTerm',
	[eCollegeTerm].[IsActive] AS 'IsActive',
	[eCollegeTerm].[TermID] AS 'TermID'
FROM [dbo].[ECollegeTerm] [eCollegeTerm]

	SET NOCOUNT OFF
END

GO

IF NOT EXISTS (SELECT NAME FROM sys.objects WHERE TYPE = 'P' AND NAME = 'GetECollegeTermByTermID')
BEGIN
	EXEC('CREATE PROCEDURE [dbo].[GetECollegeTermByTermID] AS RETURN')
END

GO

ALTER PROCEDURE [dbo].[GetECollegeTermByTermID] 
	@termID int
AS
BEGIN

	SET NOCOUNT ON
	
	SELECT
	[eCollegeTerm].[eCollegeID] AS 'eCollegeID',
	[eCollegeTerm].[eCollegeTerm] AS 'eCollegeTerm',
	[eCollegeTerm].[IsActive] AS 'IsActive',
	[eCollegeTerm].[TermID] AS 'TermID'
	FROM [dbo].[ECollegeTerm] [eCollegeTerm]
	WHERE [TermID]=@termID

	SET NOCOUNT OFF
END

GO


