﻿using System;
using System.Collections.Generic;
using System.Text;

namespace OHE.LCP.Admin.Messages.BusinessEntities
{
    /// <summary>
    /// The MessageRead class represents a read of a message by a particular LCP user.  The system uses these to keep track of messages that users have read.
    /// </summary>
    [Serializable]
    public partial class MessageRead
    {
        /// <summary>
        /// Parameterless constructor.
        /// </summary>
        public MessageRead()
        {
        }

        /// <summary>
        /// Public constructor
        /// </summary>
        /// <param name="lCPUserID">The ID of the LCP user</param>
        /// <param name="messageID">The message ID</param>
        /// <param name="messageReadID">The unique ID for this message read object</param>
        /// <param name="readDateTime">The date and time that the message was read</param>
        public MessageRead(System.String lCPUserID, System.Int32 messageID, System.Int32 messageReadID, System.DateTime readDateTime)
        {
            this.lCPUserIDField = lCPUserID;
            this.messageIDField = messageID;
            this.messageReadIDField = messageReadID;
            this.readDateTimeField = readDateTime;
        }

        private System.String lCPUserIDField;

        /// <summary>
        /// The ID of the LCP user.
        /// </summary>
        public System.String LCPUserID
        {
            get { return this.lCPUserIDField; }
            set { this.lCPUserIDField = value; }
        }

        private System.Int32 messageIDField;

        /// <summary>
        /// The ID of the message that was read.
        /// </summary>
        public System.Int32 MessageID
        {
            get { return this.messageIDField; }
            set { this.messageIDField = value; }
        }

        private System.Int32 messageReadIDField;

        /// <summary>
        /// The internal, system assigned ID for the MessageRead object.
        /// </summary>
        public System.Int32 MessageReadID
        {
            get { return this.messageReadIDField; }
            set { this.messageReadIDField = value; }
        }

        private System.DateTime readDateTimeField;

        /// <summary>
        /// The date and time that the message was read.
        /// </summary>
        public System.DateTime ReadDateTime
        {
            get { return this.readDateTimeField; }
            set { this.readDateTimeField = value; }
        }

    }
}

