﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using OHE.LCP.Admin.Messages.BusinessEntities;

namespace OHE.LCP.Admin.Messages.DataAccess
{
    /// <summary>
    /// Construct a Message object from a datareader.
    /// </summary>
    internal class GetMessageByMessageIDFactory : IDomainObjectFactory<Message>
    {
        public Message Construct(IDataReader reader)
        {
			Message message = new Message();
			
            int fromIndex = reader.GetOrdinal("From");
            if(!reader.IsDBNull(fromIndex))
            {
                message.From = reader.GetString(fromIndex);
            }

			int subjectIndex = reader.GetOrdinal("Subject"); 
            if(!reader.IsDBNull(subjectIndex))
            {
				message.Subject= reader.GetString(subjectIndex);

			}

			int statusIDIndex = reader.GetOrdinal("StatusID"); 
            if(!reader.IsDBNull(statusIDIndex))
            {
				message.StatusID= reader.GetInt32(statusIDIndex);

			}

			int startDateTimeIndex = reader.GetOrdinal("StartDateTime"); 
            if(!reader.IsDBNull(startDateTimeIndex))
            {
				if(!reader.IsDBNull(startDateTimeIndex)){
message.StartDateTime= reader.GetDateTime(startDateTimeIndex);
	}

			}

			int priorityIDIndex = reader.GetOrdinal("PriorityID"); 
            if(!reader.IsDBNull(priorityIDIndex))
            {
				message.PriorityID= reader.GetInt32(priorityIDIndex);

			}

			int messageIDIndex = reader.GetOrdinal("MessageID"); 
            if(!reader.IsDBNull(messageIDIndex))
            {
				message.MessageID= reader.GetInt32(messageIDIndex);

			}

			int endDateTimeIndex = reader.GetOrdinal("EndDateTime"); 
            if(!reader.IsDBNull(endDateTimeIndex))
            {
				if(!reader.IsDBNull(endDateTimeIndex)){
message.EndDateTime= reader.GetDateTime(endDateTimeIndex);
	}

			}

			int bodyIndex = reader.GetOrdinal("Body"); 
            if(!reader.IsDBNull(bodyIndex))
            {
				message.Body= reader.GetString(bodyIndex);

			}

            int createdDateTimeIndex = reader.GetOrdinal("CreatedDateTime");
            if (!reader.IsDBNull(createdDateTimeIndex))
            {
                message.CreatedDateTime = reader.GetDateTime(createdDateTimeIndex);
            }

            int createdByIndex = reader.GetOrdinal("CreatedBy");
            if (!reader.IsDBNull(createdByIndex))
            {
                message.CreatedBy = reader.GetString(createdByIndex);
            }

            int lastUpdatedByIndex = reader.GetOrdinal("LastUpdatedBy");
            if (!reader.IsDBNull(lastUpdatedByIndex))
            {
                message.LastUpdatedBy = reader.GetString(lastUpdatedByIndex);
            }

            int updatedDateTimeIndex = reader.GetOrdinal("UpdatedDateTime");
            if (!reader.IsDBNull(updatedDateTimeIndex))
            {
                message.UpdatedDateTime = reader.GetDateTime(updatedDateTimeIndex);
            }
           
			return message; 
        }
    }
}

