﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using OHE.LCP.Admin.Messages.BusinessEntities;

namespace OHE.LCP.Admin.Messages.DataAccess
{
    /// <summary>
    /// Construct a MessageRead object from a datareader.
    /// </summary>
    internal class GetMessageReadByMessageIDFactory : IDomainObjectFactory<MessageRead>
    {
        public MessageRead Construct(IDataReader reader)
        {
            MessageRead messageRead = new MessageRead();

            int readDateTimeIndex = reader.GetOrdinal("ReadDateTime");
            if (!reader.IsDBNull(readDateTimeIndex))
            {
                messageRead.ReadDateTime = reader.GetDateTime(readDateTimeIndex);

            }

            int messageReadIDIndex = reader.GetOrdinal("MessageReadID");
            if (!reader.IsDBNull(messageReadIDIndex))
            {
                messageRead.MessageReadID = reader.GetInt32(messageReadIDIndex);

            }

            int messageIDIndex = reader.GetOrdinal("MessageID");
            if (!reader.IsDBNull(messageIDIndex))
            {
                messageRead.MessageID = reader.GetInt32(messageIDIndex);

            }

            int lCPUserIDIndex = reader.GetOrdinal("LCPUserID");
            if (!reader.IsDBNull(lCPUserIDIndex))
            {
                messageRead.LCPUserID = reader.GetString(lCPUserIDIndex);

            }


            return messageRead;
        }
    }
}

