﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Data;
using OHE.LCP.Admin.Messages.BusinessEntities;
using OHE.LCP.Admin.Messages.DataAccess.Generic;
using System.Globalization;

namespace OHE.LCP.Admin.Messages.DataAccess
{
    /// <summary>
    /// This class is responsible for turning a selection criteria
    /// into a select statement and database query parameters.
    /// </summary>
    internal class GetMessageTargetByMessageIDAndByTargetTypeIDSelectionFactory : ISelectionFactory<GetMessageTargetByMessageIDAndByTargetTypeIDIdentity>
    {
        /// <summary>
        /// Creates the GetMessageTargetByMessageIDAndByTargetTypeIDSelectionFactory to build a select statement for
        /// the given GetMessageTargetByMessageIDAndByTargetTypeIDIdentity.
        /// </summary>
        /// <param name="GetMessageTargetByMessageIDAndByTargetTypeIDIdentity">GetMessageTargetByMessageIDAndByTargetTypeIDIdentity to select from the database.</param>      
        public GetMessageTargetByMessageIDAndByTargetTypeIDSelectionFactory()
        {
        }

		#region ISelectionFactory<GetMessageTargetByMessageIDAndByTargetTypeIDIdentity> Members
		public DbCommand ConstructSelectCommand(Database db, GetMessageTargetByMessageIDAndByTargetTypeIDIdentity getMessageTargetByMessageIDAndByTargetTypeIDIdentity)
		{
 		
            DbCommand command = db.GetStoredProcCommand("dbo.GetMessageTargetByMessageIDAndByTargetTypeID");
			db.AddInParameter(command, "messageID", DbType.Int32, getMessageTargetByMessageIDAndByTargetTypeIDIdentity.MessageID);
			db.AddInParameter(command, "targetTypeID", DbType.Int32, getMessageTargetByMessageIDAndByTargetTypeIDIdentity.TargetTypeID);
			return command;
        }
        #endregion
        
        #region IDbToBusinessEntityNameMapper Members
        /// <summary>
        /// Maps a field name in the database (usually a parameter name for a stored proc)
        /// to the corresponding business entity property name.
        /// </summary>
        /// <remarks>This method is intended for error message handling, not for reflection.</remarks>
        /// <param name="dbParameter">Name of field/parameter that the database knows about.</param>
        /// <returns>Corresponding business entity field name.</returns>
        public string MapDbParameterToBusinessEntityProperty(string dbParameter)
        {
            switch (dbParameter)
            {
				case "messageID":
					return "messageID";
				case "targetTypeID":
					return "targetTypeID";
				default:
					throw new ArgumentException(string.Format(CultureInfo.CurrentCulture, GenericResources.InvalidParameterName), dbParameter);
			}
        }
        #endregion  
    }
}

