﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using OHE.LCP.Admin.Messages.BusinessEntities;

namespace OHE.LCP.Admin.Messages.DataAccess
{
    /// <summary>
    /// Construct a MessageTarget object from a datareader.
    /// </summary>
    internal class GetMessageTargetByMessageIDFactory : IDomainObjectFactory<MessageTarget>
    {
        public MessageTarget Construct(IDataReader reader)
        {
            MessageTarget messageTarget = new MessageTarget();

            int targetTypeIDIndex = reader.GetOrdinal("TargetTypeID");
            if (!reader.IsDBNull(targetTypeIDIndex))
            {
                messageTarget.TargetTypeID = reader.GetInt32(targetTypeIDIndex);

            }

            int targetIDIndex = reader.GetOrdinal("TargetID");
            if (!reader.IsDBNull(targetIDIndex))
            {
                messageTarget.TargetID = reader.GetString(targetIDIndex);

            }

            int messageTargetIDIndex = reader.GetOrdinal("MessageTargetID");
            if (!reader.IsDBNull(messageTargetIDIndex))
            {
                messageTarget.MessageTargetID = reader.GetInt32(messageTargetIDIndex);

            }

            int messageIDIndex = reader.GetOrdinal("MessageID");
            if (!reader.IsDBNull(messageIDIndex))
            {
                messageTarget.MessageID = reader.GetInt32(messageIDIndex);

            }

            int descriptionIndex = reader.GetOrdinal("Description");
            if (!reader.IsDBNull(descriptionIndex))
            {
                messageTarget.Description = reader.GetString(descriptionIndex);
            }

            return messageTarget;
        }
    }
}

