using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using OHE.LCP.Admin.ServiceContracts;
using OHE.LCP.Admin.Messages;
using OHE.LCP.Admin.Messages.Services;
using OHE.LCP.Admin.Messages.BusinessEntities;
using OHE.LCP.Admin.DataContracts;

namespace OHE.LCP.Admin.ServiceImplementation
{
    [ServiceBehavior(Name = "MessagesService", Namespace = "http://OHE.LCP.Admin.ServiceContracts/2007/09")]
    public class MessagesService : OHE.LCP.Admin.ServiceContracts.IMessagesService
    {
        #region IMessagesService Members

        public GetMessagesResponse GetMessages(GetMessagesRequest request)
        {
            MessageService _messageService = new OHE.LCP.Admin.Messages.Services.MessageService();

            //Take the string arrays from the request object and create comma delimited strings for the service object
            string _roleIDs = String.Join(",", request.RoleIDs);
            string _schoolIDs = String.Join(",", request.SchoolIDs);
            string _programIDs = String.Join(",", request.ProgramIDs);
            string _concentrationIDs = String.Join(",", request.ConcentrationIDs);
            string _courseIDs = String.Join(",", request.CourseIDs);
            string _sectionIDs = String.Join(",", request.SectionIDs);

            List<OHE.LCP.Admin.Messages.BusinessEntities.Message> _messages = _messageService.GetMessagesForLCP(_roleIDs, _schoolIDs, _programIDs, _concentrationIDs, _courseIDs, _sectionIDs, request.PersonID);
            GetMessagesResponse _response = new GetMessagesResponse();
            _response.Messages = new List<OHE.LCP.Admin.DataContracts.Message>();
            foreach (OHE.LCP.Admin.Messages.BusinessEntities.Message _message in _messages)
            {
                OHE.LCP.Admin.DataContracts.Message _dataMessage = new OHE.LCP.Admin.DataContracts.Message();
                _dataMessage.Body = _message.Body;
                _dataMessage.EndDateTime = _message.EndDateTime;
                _dataMessage.MessageID = _message.MessageID;
                _dataMessage.PriorityID = _message.PriorityID;
                _dataMessage.StartDateTime = _message.StartDateTime;
                _dataMessage.StatusID = _message.StatusID;
                _dataMessage.Subject = _message.Subject;
                _dataMessage.IsRead = false;
                _dataMessage.From = _message.From;
                _dataMessage.CreatedBy = _message.CreatedBy;
                _dataMessage.CreatedDateTime = _message.CreatedDateTime;
                _dataMessage.LastUpdatedBy = _message.LastUpdatedBy;
                _dataMessage.LastUpdatedDateTime = _message.UpdatedDateTime;
                if (_message.MessageReads != null)
                {
                    if (_message.MessageReads.Count > 0)
                    {
                        foreach (OHE.LCP.Admin.Messages.BusinessEntities.MessageRead _messageRead in _message.MessageReads)
                        {
                            if (_messageRead.LCPUserID == request.PersonID)
                            {
                                _dataMessage.IsRead = true;
                            }
                        }
                    }
                }
                _response.Messages.Add(_dataMessage);
            }
            return _response;
        }

        public AddMessageReadResponse AddMessageRead(AddMessageReadRequest request)
        {
            MessageService _messageService = new MessageService();
            _messageService.ReadMessage(request.MessageID, request.LCPUserID, request.ReadDateTime);
            AddMessageReadResponse _response = new AddMessageReadResponse();
            _response.Result = true;
            return _response;
        }

        #endregion
    }
}
