﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Practices.ObjectBuilder;
using OHE.LCP.Admin.CourseCopying.Views;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;
using System.Collections.Generic;
using System.Text;
using OHE.LCP.Admin.CourseCopying.Resources;
using OHE.LCP.Admin.CourseCopying;

public partial class CourseCopying_Confirm : System.Web.UI.Page, IConfirm
{
    private ConfirmPresenter _presenter;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            this._presenter.OnViewInitialized();
        }
        this._presenter.OnViewLoaded();
    }

    [CreateNew]
    public ConfirmPresenter Presenter
    {
        set
        {
            this._presenter = value;
            this._presenter.View = this;
        }
    }

    public IList<Course> Courses
    {
        set { CoursesDataSource.DataSource = value; }
    }

    protected void SelectedCourses_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
    {
        if (e.Item.ItemType == Telerik.Web.UI.GridItemType.Item || e.Item.ItemType == Telerik.Web.UI.GridItemType.AlternatingItem)
        {
            //Get a reference to the data item
            Course _course = (Course)e.Item.DataItem;

            //Get references to the controls
            Label _lblSchool = (Label)e.Item.FindControl("lblSchool");
            Label _lblCourse = (Label)e.Item.FindControl("lblCourse");
            Label _lbleCollegeMaster = (Label)e.Item.FindControl("lbleCollegeMaster");
            Label _lbleCollegeTerm = (Label)e.Item.FindControl("lbleCollegeTerm");
            Label _lblCourseStartDate = (Label)e.Item.FindControl("lblCourseStartDate");
            GridView _grdSectionsInstructor = (GridView)e.Item.FindControl("grdSectionsInstructor");

            //School - course start date
            if (_course.Sections.Count > 0)
            { 
                //Set the school to the name of the school for the first section for the course
                _lblSchool.Text = _course.Sections[0].SchoolName;
                //Set the start date to the start date of the first section for the course
                _lblCourseStartDate.Text = _course.Sections[0].CourseStartDate.ToShortDateString();
            }
            else { 
                _lblSchool.Text = "";
                _lblCourseStartDate.Text = "";
            }
            //Course
            _lblCourse.Text = _course.CourseCode + ' ' + _course.CourseTitle;
            //ECollege Master
            _lbleCollegeMaster.Text = _course.SelectedMasterCourse.CourseDisplayCode + ' ' + _course.SelectedMasterCourse.CourseTitle;
            //Sections/Instructor
            //Filter out the unneeded sections - this selects only the sections that match the term and subterm
            SectionByTermSubTermFinder _sectionFinder = new SectionByTermSubTermFinder(Session[Constants.SessionKeys.SelectedTerm].ToString(), Session[Constants.SessionKeys.SelectedSubTerm].ToString());
            //Apply the filter
            List<Section> _sections = ((List<Section>)_course.Sections).FindAll(_sectionFinder.Test);
            _sections.Sort();
            //Set the data grid source and bind it for the sections and instructors
            _grdSectionsInstructor.DataSource = _sections;
            _grdSectionsInstructor.DataBind();
            //ECollege Term
            ECollegeTerm _eCollegeTerm = (ECollegeTerm)Session[Constants.SessionKeys.SelectedECollegeTerm];
            _lbleCollegeTerm.Text = _eCollegeTerm.eCollegeTerm;
        }
    }

    protected void btnBack_Click(object sender, EventArgs e)
    {
        _presenter.OnBackClick();
    }
    protected void btnConfirm_Click(object sender, EventArgs e)
    {
        _presenter.OnConfirmClick();
    }
}



