﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Practices.ObjectBuilder;
using OHE.LCP.Admin.CourseCopying.Views;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;
using System.Collections.Generic;

public partial class CourseCopying_DefaultMapping : System.Web.UI.Page, IDefaultMapping
{
    private DefaultMappingPresenter _presenter;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            this._presenter.OnViewInitialized();
        }
        this._presenter.OnViewLoaded();
    }

    [CreateNew]
    public DefaultMappingPresenter Presenter
    {
        set
        {
            this._presenter = value;
            this._presenter.View = this;
        }
    }

    public IList<Course> Courses
    {
        set { DefaultMappingDataSource.DataSource = value; }
    }

    protected void DefaultMappingGrid_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
    {
        if (e.Item.ItemType == Telerik.Web.UI.GridItemType.Item ||
            e.Item.ItemType == Telerik.Web.UI.GridItemType.AlternatingItem)
        {
            //Get the course object
            Course _course = (Course)e.Item.DataItem;

            //Get references to the controls
            Label _lblCourseDisplayCode = (Label)e.Item.FindControl("lblCourseDisplayCode");
            Label _lblCourseTitle = (Label)e.Item.FindControl("lblCourseTitle");
            Label _lblECollegeID = (Label)e.Item.FindControl("lblECollegeID");
            Label _lblSourceNode = (Label)e.Item.FindControl("lblSourceNode");
            Label _lblCrsCode = (Label)e.Item.FindControl("lblCrsCode");
            Label _lblCrsTitle = (Label)e.Item.FindControl("lblCrsTitle");
            HyperLink _hypEdit = (HyperLink)e.Item.FindControl("hypEdit");

            //Set the source node for the course from the banner course
            _lblCrsCode.Text = _course.CourseCode;
            _lblCrsTitle.Text = _course.CourseTitle;
            _lblSourceNode.Text = _course.Sections[0].SectionNode.Node;

            if (_course.Master_Course == null)
            {
                //This banner course has no master course - so set the labels to nothing, set the hyperlink to New
                _lblCourseDisplayCode.Text = "";
                _lblCourseTitle.Text = "";
                _lblECollegeID.Text = "";
                _hypEdit.Text = "New";
                _hypEdit.NavigateUrl = "javascript:doPopUp('" + _course.CourseCode + "','')";
            }
            else 
            {
                //This banner course does have an assigned master course - so display all of the master course info
                _lblCourseDisplayCode.Text = _course.Master_Course.CourseDisplayCode;
                _lblCourseTitle.Text = _course.Master_Course.CourseTitle;
                _lblECollegeID.Text = _course.Master_Course.eCollegeID;
                _hypEdit.NavigateUrl = "javascript:doPopUp('" + _course.CourseCode + "','" + _course.SelectedMasterCourse.MasterCourseID.ToString() + "')";
            }
        }
    }
}


