﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Practices.ObjectBuilder;
using OHE.LCP.Admin.CourseCopying.Views;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;
using System.Collections.Generic;
using Telerik.Web.UI;

public partial class CourseCopying_DefaultMappingPopUp : System.Web.UI.Page, IDefaultMappingPopUp
{
    private DefaultMappingPopUpPresenter _presenter;
    private string _masterCourseID = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            this._presenter.OnViewInitialized();
        }
        this._presenter.OnViewLoaded();
    }

    [CreateNew]
    public DefaultMappingPopUpPresenter Presenter
    {
        set
        {
            this._presenter = value;
            this._presenter.View = this;
        }
    }

    public IList<MasterCourse> MasterCourses
    {
        set { MasterCoursesDataSource.DataSource = value; }
    }

    public Course BannerCourse
    {
        set 
        { 
            //Set the labels at the top of the screen
            this.lblBannerCourse.Text = value.CourseCode + " - " + value.CourseTitle;
            if (value.Master_Course != null)
            {
                this.lblMasterCourse.Text = value.Master_Course.CourseDisplayCode + " - " + value.Master_Course.CourseTitle;
                _masterCourseID = value.Master_Course.MasterCourseID.ToString();
            }
        }
    }

    protected void RadGrid1_ItemCreated(object sender, EventArgs e)
    {
        GridItemCollection coll = ((Telerik.Web.UI.RadGrid)sender).SelectedItems;
        GridItem selected = coll[0];
        this.lblMasterCourse.Text = selected.Cells[3].Text + " - " + selected.Cells[4].Text;
    }

    protected void MasterCourseGrid_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
    {
        if (e.Item.ItemType == Telerik.Web.UI.GridItemType.Item ||
            e.Item.ItemType == Telerik.Web.UI.GridItemType.AlternatingItem)
        {
            //Check to see if the Master Course ID matches the ID from the selected Banner Course
            MasterCourse _masterCourse = (MasterCourse)e.Item.DataItem;

            if (_masterCourse.MasterCourseID.ToString() == _masterCourseID)
            {
                //This row should be selected
                ((Telerik.Web.UI.GridDataItem)e.Item).Selected = true;
            }
        }
    }

    protected void btnSave_Click(object sender, EventArgs e)
    {
        int rowIndex = this.MasterCourseGrid.MasterTableView.ChildSelectedItems[0].ItemIndex;//adjust for header
        int courseId = Convert.ToInt32(this.MasterCourseGrid.MasterTableView.DataKeyValues[rowIndex][this.MasterCourseGrid.MasterTableView.DataKeyNames[0]]);
        _presenter.OnSaveClick(courseId);
    }
}


