﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Practices.ObjectBuilder;
using OHE.LCP.Admin.CourseCopying.Views;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;
using System.Collections.Generic;

public partial class CourseCopying_History : System.Web.UI.Page, IHistory
{
    private HistoryPresenter _presenter;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            this._presenter.OnViewInitialized();
            //Check for a batch number in the query string
            if (Request.QueryString["batch"] != null)
            {
                //Set the drop down to the requested batch
                ddlBatches.SelectedValue = Request.QueryString["batch"];
                //Get the items for the requested batch
                this._presenter.OnGetCopyHistoryItems(Request.QueryString["batch"]);
            }
        }
        this._presenter.OnViewLoaded();
    }

    [CreateNew]
    public HistoryPresenter Presenter
    {
        set
        {
            this._presenter = value;
            this._presenter.View = this;
        }
    }

    public IList<Batch> Batches
    {
        set { BatchesDataSource.DataSource = value; }
    }

    public IList<CopyHistory> CopyHistoryItems
    {
        set { CopyHistoryItemsDataSource.DataSource = value; }
    }

    protected void ddlBatches_SelectedIndexChanged(object sender, EventArgs e)
    {
        //When the batches drop down list is changed, get the list of copy history items to display
        if (ddlBatches.SelectedValue != "")
        {
            this._presenter.OnGetCopyHistoryItems(ddlBatches.SelectedValue);
        }
    }
}


