﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="MasterCourses.aspx.cs" Inherits="CourseCopying_MasterCourses"
    Title="MasterCourses" MasterPageFile="~/Shared/Default.master" %>

<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>
<%@ Register Assembly="Microsoft.Practices.Web.UI.WebControls" Namespace="Microsoft.Practices.Web.UI.WebControls"
    TagPrefix="pp" %>
    
<%@ Import Namespace="OHE.LCP.Admin.CourseCopying.BusinessEntities" %>

<asp:Content ID="content" ContentPlaceHolderID="DefaultContent" Runat="Server">
	<h1>Manage Master Courses</h1>
	<div id="WarningDiv" runat="server" visible="false">
	    <asp:Label ID="lblWarning" runat="server" ForeColor="red"></asp:Label>
	</div>
	    <table cellpadding="0" cellspacing="0" border="0">
        <tr>
            <td>
                <asp:Image ID="Image1" ImageUrl="~/Images/AddRecord.gif" runat="server" /></td>
            <td>
               <asp:HyperLink ID="lnkAdd" runat="server" Text="Add New Master Course" NavigateUrl="~/CourseCopying/MasterCourses.aspx?mode=insert"></asp:HyperLink></td>
        </tr>
    </table><br />
	
	<asp:ValidationSummary ID="ValSummary" runat="server" DisplayMode="BulletList" EnableClientScript="true" HeaderText="The following errors occurred:" ShowSummary="true" />
    <asp:DetailsView ID="MasterCourseDetailsView" runat="server" AutoGenerateRows="false" DataKeyNames="MasterCourseID" GridLines="none" DataSourceID="MasterCourseDataSource" BorderStyle="solid" BorderColor="black" BorderWidth="1" BackColor="white" CellPadding="5" Visible="false" OnModeChanging="MasterCourseDetailsView_ModeChanging" >
        <FieldHeaderStyle HorizontalAlign="right" />
        <CommandRowStyle HorizontalAlign="right" />
        <Fields>
            <asp:TemplateField HeaderText="Course Display Code">
                <ItemTemplate>
                    <asp:TextBox ID="txtCourseDisplayCode" runat="server" Text='<%# Bind("CourseDisplayCode") %>' Width="150" MaxLength="50"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="CourseDisplayCodeValidator" runat="server" ErrorMessage="Course Display Code is required." ControlToValidate="txtCourseDisplayCode" EnableClientScript="true" Display="dynamic">*</asp:RequiredFieldValidator>
                </ItemTemplate>
            </asp:TemplateField>
            <asp:TemplateField HeaderText="Title">
                <ItemTemplate>
                    <asp:TextBox ID="txtTitle" runat="server" Text='<%# Bind("CourseTitle") %>' Width="400" MaxLength="100"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="TitleValidator" runat="server" ErrorMessage="Title is required." ControlToValidate="txtTitle" EnableClientScript="true" Display="dynamic">*</asp:RequiredFieldValidator>
                </ItemTemplate>
            </asp:TemplateField>
            <asp:TemplateField HeaderText="eCollege ID">
                <ItemTemplate>
                    <asp:TextBox ID="txteCollegeID" runat="server" Text='<%# Bind("eCollegeID") %>' Width="150" MaxLength="7"></asp:TextBox>
                    <asp:RequiredFieldValidator ID="ECollegeIDValidator" runat="server" ErrorMessage="eCollege ID is required." ControlToValidate="txteCollegeID" EnableClientScript="true" Display="dynamic">*</asp:RequiredFieldValidator>
                </ItemTemplate>
            </asp:TemplateField>
            <asp:TemplateField HeaderText="Status">
                <ItemTemplate>
                    <asp:RadioButtonList ID="rdoIsActive" runat="server" RepeatDirection="Horizontal" SelectedValue='<%# Bind("IsActive") %>'>
                        <asp:ListItem Text="Active" Value="True" Selected="true"></asp:ListItem>
                        <asp:ListItem Text="Inactive" Value="False"></asp:ListItem>
                    </asp:RadioButtonList>
                    <asp:RequiredFieldValidator ID="StatusValidator" runat="server" ErrorMessage="Status is required." ControlToValidate="rdoIsActive" EnableClientScript="true" Display="dynamic">*</asp:RequiredFieldValidator>
                </ItemTemplate>
            </asp:TemplateField>
            <asp:CommandField ButtonType="Button" ShowCancelButton="true" ShowEditButton="true" ShowInsertButton="true" EditText="Save" InsertText="Save" UpdateText="Save" />
        </Fields>
    </asp:DetailsView>
    <br />
    <telerik:RadGrid Width="900px" AutoGenerateColumns="false" ID="MasterCourseGrid" DataSourceID="MasterCoursesDataSource" runat="server" OnItemDataBound="MasterCourseGrid_ItemDataBound">
        <MasterTableView>
            <Columns>
                <telerik:GridHyperLinkColumn HeaderImageUrl="~/Images/Edit.gif" Text="Edit" DataNavigateUrlFields="MasterCourseID" DataNavigateUrlFormatString="MasterCourses.aspx?mode=edit&amp;id={0}" HeaderStyle-Width="30px" />
                <telerik:GridBoundColumn DataField="CourseDisplayCode" HeaderText="Course"/>
                <telerik:GridBoundColumn DataField="CourseTitle" HeaderText="Title" />
                <telerik:GridBoundColumn DataField="eCollegeID" HeaderText="eCollege ID"/>
                <telerik:GridTemplateColumn HeaderText="Status">
                    <ItemTemplate><asp:Label ID="lblStatus" runat="server"></asp:Label></ItemTemplate>
                </telerik:GridTemplateColumn>
            </Columns>
        </MasterTableView>
    </telerik:RadGrid>
    <pp:ObjectContainerDataSource ID="MasterCoursesDataSource" runat="server" DataObjectTypeName="OHE.LCP.Admin.CourseCopying.BusinessEntities.MasterCourse" />
    <pp:ObjectContainerDataSource ID="MasterCourseDataSource" runat="server" DataObjectTypeName="OHE.LCP.Admin.CourseCopying.BusinessEntities.MasterCourse" OnInserted="MasterCourseDataSource_Inserted" OnUpdated="MasterCourseDataSource_Updated" OnUpdating="MasterCourseDataSource_Updating" />
</asp:Content>
