﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Practices.ObjectBuilder;
using OHE.LCP.Admin.CourseCopying.Views;
using OHE.LCP.Admin.CourseCopying.BusinessEntities;
using System.Collections.Generic;
using OHE.LCP.Admin.CourseCopying;

public partial class CourseCopying_Terms : System.Web.UI.Page, ITerms
{
    private TermsPresenter _presenter;
    private string _mode;

    protected void Page_Load(object sender, EventArgs e)
    {
        //Get the mode from the query string
        _mode = Page.Request.QueryString["mode"];
        switch (_mode)
        {
            case "insert":
                //Set the mode for the details view
                ECollegeTermDetailsView.DefaultMode = DetailsViewMode.Insert;
                ECollegeTermDetailsView.Visible = true;
                break;
            case "edit":
                //Set the mode for the details view
                ECollegeTermDetailsView.DefaultMode = DetailsViewMode.Edit;
                ECollegeTermDetailsView.Visible = true;
                //Get the actual message from the presenter
                this._presenter.OnGetECollegeTerm(Convert.ToInt32(Page.Request.QueryString["id"]));
                break;
            default:
                ECollegeTermDetailsView.DefaultMode = DetailsViewMode.Insert;
                break;
        }

        if (!this.IsPostBack)
        {
            this._presenter.OnViewInitialized();
        }
        this._presenter.OnViewLoaded();
    }

    [CreateNew]
    public TermsPresenter Presenter
    {
        set
        {
            this._presenter = value;
            this._presenter.View = this;
        }
    }

    public IList<ECollegeTerm> ECollegeTerms
    {
        set { ECollegeTermsDataSource.DataSource = value; }
    }

    public ECollegeTerm ecollegeTerm
    {
        set { ECollegeTermDataSource.DataSource = value; }
    }

    protected void ECollegeTermDetailsView_ModeChanging(object sender, DetailsViewModeEventArgs e)
    {
        if (e.CancelingEdit)
        {
            ECollegeTermDetailsView.Visible = false;
        }
    }
    protected void ECollegeTermGrid_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
    {
        if (e.Item.ItemType == Telerik.Web.UI.GridItemType.Item ||
            e.Item.ItemType == Telerik.Web.UI.GridItemType.AlternatingItem)
        {
            //Find the status label
            Label _label = (Label)e.Item.FindControl("lblStatus");
            //Get the term for this row
            ECollegeTerm _dataItem = (ECollegeTerm)e.Item.DataItem;
            //Set the status label appropriately
            if (_dataItem.IsActive)
            { _label.Text = "Active"; }
            else 
            { 
                _label.Text = "Inactive";
                _label.ForeColor = System.Drawing.Color.Red;
            }
        }
    }
    protected void ECollegeTermDataSource_Inserted(object sender, Microsoft.Practices.Web.UI.WebControls.ObjectContainerDataSourceStatusEventArgs e)
    {
        ECollegeTerm _eCollegeTerm = (ECollegeTerm)e.Instance;
        _presenter.OnInsertECollegeTerm(_eCollegeTerm);
    }
    protected void ECollegeTermDataSource_Updated(object sender, Microsoft.Practices.Web.UI.WebControls.ObjectContainerDataSourceStatusEventArgs e)
    {
        ECollegeTerm _eCollegeTerm = (ECollegeTerm)e.Instance;
        _presenter.OnUpdateECollegeTerm(_eCollegeTerm);
    }
    protected void ECollegeTermDetailsView_ItemInserted(object sender, DetailsViewInsertedEventArgs e)
    {
        Response.Redirect(Constants.URLs.Terms);
    }
    protected void ECollegeTermDetailsView_ItemUpdated(object sender, DetailsViewUpdatedEventArgs e)
    {
        Response.Redirect(Constants.URLs.Terms);
    }
}


