using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using OHE.LCP.Admin.Messages;

public partial class Messages_CourseSearch : System.Web.UI.Page
{
    int rowCounter = 0;
    string strScript = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        //Set the search text label
        SearchTextLabel.Text = Request.QueryString["search"];

        //Add attributes to the buttons for client javascript
        this.SubmitButton.Attributes.Add("OnClick", "returnValues()");
        this.CancelButton.Attributes.Add("OnClick", "window.close()");

        //Add arrays to the script string
        strScript = "<script language='javascript' type='text/javascript'>";
        strScript += "var ClientIDList = new Array();";
        strScript += "var ItemIDList = new Array();";
        strScript += "var DescriptionList = new Array();";
    }

    protected void searchDataSource_Selected(object sender, SqlDataSourceStatusEventArgs e)
    {
        //Set the number of rows that were returned
        SearchNumberLabel.Text = "returned " + e.AffectedRows.ToString() + " matches.";
    }

    protected void SearchButton_Click(object sender, EventArgs e)
    {
        //Do a new search
        Response.Redirect(Constants.URLs.CourseSearch + "?search=" + SearchTextBox.Text);

    }

    protected void SearchGrid_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            //Get a reference to the checkbox
            CheckBox itemCheckbox = (CheckBox)e.Row.FindControl("chkSelected");

            //Add lines to the javascript
            strScript += "ClientIDList[" + rowCounter.ToString() + "] = '" + itemCheckbox.ClientID.ToString() + "';";
            strScript += "ItemIDList[" + rowCounter.ToString() + "] = '" + SearchGrid.DataKeys[e.Row.DataItemIndex].Value.ToString() + "';";
            DataRowView RowItem = (DataRowView)e.Row.DataItem;
            strScript += "DescriptionList[" + rowCounter.ToString() + "] = '" + RowItem.Row["Code"] + " - " + RowItem.Row["Title"] + "';";
            
            //Set the row counter label
            rowCounter += 1;
            Label CounterLabel = (Label)e.Row.FindControl("lblCounter");
            CounterLabel.Text = rowCounter.ToString() + ".";
        }
    }
    protected void SearchGrid_DataBound(object sender, EventArgs e)
    {
        //After the grid is bound finish adding the javascript to the script string and register the script block
        strScript += "function returnValues(){var iCounter;var chkItem;var ret = '';for (iCounter in ClientIDList){chkItem = document.getElementById(ClientIDList[iCounter]);if(chkItem.checked){if(ret == ''){ret = ItemIDList[iCounter] + '|' + DescriptionList[iCounter];}else{ret = ret + '|' + ItemIDList[iCounter] + '|' + DescriptionList[iCounter];}} }var retVal = new Array(ret);window.returnValue = retVal;window.close();}";
        strScript += "</script>";
        ClientScriptManager cs = Page.ClientScript;
        if(!cs.IsClientScriptBlockRegistered("returnValues"))
        {
            cs.RegisterClientScriptBlock(this.GetType(), "returnValues", strScript);
        }
    }
}
