﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Practices.ObjectBuilder;
using OHE.LCP.Admin.Messages.Views;
using OHE.LCP.Admin.Messages.BusinessEntities;
using System.Collections.Generic;
using Telerik.Web.UI;

public partial class Messages_MessageList : System.Web.UI.Page, IMessageList
{
    private MessageListPresenter _presenter;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            //Call the presenter's initialized
            this._presenter.OnViewInitialized();
        }
        //Call the presenter's loaded
        this._presenter.OnViewLoaded();
    }

    /// <summary>
    /// Gets the DIV for the selected message body
    /// </summary>
    public HtmlGenericControl MessageBody
    {
        get { return (HtmlGenericControl)this.RadPanel2.FindControl("MessageBodyDiv"); }
    }

    /// <summary>
    /// Gets the id of the selected message
    /// </summary>
    public int? SelectedMessageID
    {
        get 
        {
            int result;
            if (Int32.TryParse(Request["messageid"], out result))
                return result;
            else return null;
        }
    }

    /// <summary>
    /// This RadGrid for the listing page
    /// </summary>
    public RadGrid MessageGrid
    {
        get { return this.MessageList; }
    }

    /// <summary>
    /// The list of message for the listing page
    /// </summary>
    public IList<Message> Messages
    {
        set { MessagesDataSource.DataSource = value;}
    }

    /// <summary>
    /// The Presenter for this page
    /// </summary>
    [CreateNew]
    public MessageListPresenter Presenter
    {
        set
        {
            this._presenter = value;
            this._presenter.View = this;
        }
    }
}



