using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Practices.ObjectBuilder;
using OHE.Security.DataTypes;
using Microsoft.Practices.CompositeWeb.Utility;
using OHE.Admin.Security.Module.Views;

public partial class Security_ActionDetail : System.Web.UI.Page, IActionDetailsView
{
    private ActionDetailsPresenter _presenter;
    private string _mode;
    
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            _mode = Page.Request.QueryString["mode"];
            switch (_mode)
            {
                case "insert":
                    //Set the mode for the details view
                    ActionDetailsView.DefaultMode = DetailsViewMode.Insert;
                    break;
                case "edit":
                    //Set the mode for the details view
                    ActionDetailsView.DefaultMode = DetailsViewMode.Edit;
                    //Get the actual institution from the presenter
                    this._presenter.OnGetAction(Convert.ToInt32(Page.Request.QueryString["id"]));
                    break;
                default:
                    ActionDetailsView.DefaultMode = DetailsViewMode.Insert;
                    break;
            }
            
            //Call the presenter's initialized
            this._presenter.OnViewInitialized();
        }
        //Call the presenter's loaded
        this._presenter.OnViewLoaded();
    }

    [CreateNew]
    public ActionDetailsPresenter Presenter
    {
        get
        {
            return _presenter;
        }
        set
        {
            _presenter = value;
            _presenter.View = this;
        }
    }

    protected void ActionDataSource_Inserted(object sender, Microsoft.Practices.Web.UI.WebControls.ObjectContainerDataSourceStatusEventArgs e)
    {
        _presenter.OnActionInserted((Action)e.Instance);
    }
    protected void ActionDataSource_Updated(object sender, Microsoft.Practices.Web.UI.WebControls.ObjectContainerDataSourceStatusEventArgs e)
    {
        _presenter.OnActionUpdated((Action)e.Instance);
    }

    //Redirect back to the list if the user clicked Cancel
    protected void ActionDetailsView_ModeChanging(object sender, DetailsViewModeEventArgs e)
    {
        if (e.CancelingEdit == true)
        {
            _presenter.OnCancel();
        }
    }

    #region IActionDetailsView Members

    public OHE.Security.DataTypes.Action Action
    {
         set { this.ActionDataSource.DataSource = value; }
    }

    public int SecurityContextID
    {
        get
        {
            Guard.ArgumentNotNull(Page.Request.QueryString["securitycontextid"], "SecurityContextID");
            return Convert.ToInt32(Page.Request.QueryString["securitycontextid"]);
        }
    }

    #endregion
}
