using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using OHE.Admin.Security.Module.Views;
using Microsoft.Practices.ObjectBuilder;
using OHE.Security.DataTypes;
using Microsoft.Practices.CompositeWeb.Utility;

public partial class Security_ActionList : System.Web.UI.Page, IActionListView
{
    private ActionListPresenter _presenter;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            //Call the presenter's initialized
            this._presenter.OnViewInitialized();
        }
        //Call the presenter's loaded
        this._presenter.OnViewLoaded();

        this.DataBind();

    }

    [CreateNew]
    public ActionListPresenter Presenter
    {
        get
        {
            return _presenter;
        }
        set
        {
            _presenter = value;
            _presenter.View = this;
        }
    }

    protected void ActionDataSource_Deleted(object sender, Microsoft.Practices.Web.UI.WebControls.ObjectContainerDataSourceStatusEventArgs e)
    {
        _presenter.OnActionDeleted((Action)e.Instance);
    }

    #region IActionList Members

    public System.Collections.Generic.IList<OHE.Security.DataTypes.Action> Actions
    {
        set
        {
            this.ActionDataSource.DataSource = value;
        }
    }

    public int SecurityContextID
    {
        get 
        {
            Guard.ArgumentNotNull(Page.Request.QueryString["securitycontextid"], "SecurityContextID");
            return Convert.ToInt32(Page.Request.QueryString["securitycontextid"]);
        }
    }

    #endregion
}
