using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Practices.ObjectBuilder;
using OHE.Security.DataTypes;
using OHE.Admin.Security.Module.Views;

public partial class Security_InstitutionDetail : System.Web.UI.Page, IInstitutionDetailsView
{
    private InstitutionDetailsPresenter _presenter;
    private string _mode;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            _mode = Page.Request.QueryString["mode"];
            switch (_mode)
            {
                case "insert":
                    //Set the mode for the details view
                    InstitutionDetailsView.DefaultMode = DetailsViewMode.Insert;
                    break;
                case "edit":
                    //Set the mode for the details view
                    InstitutionDetailsView.DefaultMode = DetailsViewMode.Edit;
                    //Get the actual institution from the presenter
                    this._presenter.OnGetInstitution(Convert.ToInt32(Page.Request.QueryString["id"]));
                    break;
                default:
                    InstitutionDetailsView.DefaultMode = DetailsViewMode.Insert;
                    break;
            }

            //Call the presenter's initialized
            this._presenter.OnViewInitialized();
        }
        //Call the presenter's loaded
        this._presenter.OnViewLoaded();
    }

    [CreateNew]
    public InstitutionDetailsPresenter Presenter
    {
        get
        {
            return _presenter;
        }
        set
        {
            _presenter = value;
            _presenter.View = this;
        }
    }

    protected void InstitutionDataSource_Inserted(object sender, Microsoft.Practices.Web.UI.WebControls.ObjectContainerDataSourceStatusEventArgs e)
    {
        _presenter.OnInstitutionInserted((Institution)e.Instance);
    }
    protected void InstitutionDataSource_Updated(object sender, Microsoft.Practices.Web.UI.WebControls.ObjectContainerDataSourceStatusEventArgs e)
    {
        _presenter.OnInstitutionUpdated((Institution)e.Instance);
    }

    //Redirect back to the list if the user clicked Cancel
    protected void InstitutionDetailsView_ModeChanging(object sender, DetailsViewModeEventArgs e)
    {
        if (e.CancelingEdit == true)
        {
            _presenter.OnCancel();
        }
    }


    #region IInstitutionDetailsView Members

    public OHE.Security.DataTypes.Institution Institution
    {
        set { this.InstitutionDataSource.DataSource = value; }
    }

    #endregion
}
