using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using OHE.Admin.Security.Module.Views;
using Microsoft.Practices.ObjectBuilder;
using OHE.Security.DataTypes;

public partial class Security_InstitutionList : System.Web.UI.Page, IInstitutionListView
{
    private InstitutionListPresenter _presenter;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            //Call the presenter's initialized
            this._presenter.OnViewInitialized();
        }
        //Call the presenter's loaded
        this._presenter.OnViewLoaded();

    }

    [CreateNew]
    public InstitutionListPresenter Presenter
    {
        get
        {
            return _presenter;
        }
        set
        {
            _presenter = value;
            _presenter.View = this;
        }
    }

    protected void InstitutionDataSource_Deleted(object sender, Microsoft.Practices.Web.UI.WebControls.ObjectContainerDataSourceStatusEventArgs e)
    {
        _presenter.OnInstitutionDeleted((Institution)e.Instance);
    }

    #region IInstitutionList Members

    public System.Collections.Generic.IList<OHE.Security.DataTypes.Institution> Institutions
    {
        set
        {
            this.InstitutionDataSource.DataSource = value;
        }
    }

    #endregion
}
