using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Practices.ObjectBuilder;
using OHE.Security.DataTypes;
using OHE.Admin.Security.Module.Views;

public partial class Security_SecurityContextDetail : System.Web.UI.Page, ISecurityContextDetailsView
{
    private SecurityContextDetailsPresenter _presenter;
    private string _mode;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            _mode = Page.Request.QueryString["mode"];
            switch (_mode)
            {
                case "insert":
                    //Set the mode for the details view
                    SecurityContextDetailsView.DefaultMode = DetailsViewMode.Insert;
                    break;
                case "edit":
                    //Set the mode for the details view
                    SecurityContextDetailsView.DefaultMode = DetailsViewMode.Edit;
                    //Get the actual securityconext from the presenter
                    this._presenter.OnGetSecurityContext(Convert.ToInt32(Page.Request.QueryString["id"]));
                    break;
                default:
                    SecurityContextDetailsView.DefaultMode = DetailsViewMode.Insert;
                    break;
            }

            //Call the presenter's initialized
            this._presenter.OnViewInitialized();
        }
        //Call the presenter's loaded
        this._presenter.OnViewLoaded();
    }

    [CreateNew]
    public SecurityContextDetailsPresenter Presenter
    {
        get
        {
            return _presenter;
        }
        set
        {
            _presenter = value;
            _presenter.View = this;
        }
    }

    protected void SecurityContextDataSource_Inserted(object sender, Microsoft.Practices.Web.UI.WebControls.ObjectContainerDataSourceStatusEventArgs e)
    {
        _presenter.OnSecurityContextInserted((SecurityContext)e.Instance);
    }
    protected void SecurityContextDataSource_Updated(object sender, Microsoft.Practices.Web.UI.WebControls.ObjectContainerDataSourceStatusEventArgs e)
    {
        _presenter.OnSecurityContextUpdated((SecurityContext)e.Instance);
    }


    //Redirect back to the list if the user clicked Cancel
    protected void SecurityContextDetailsView_ModeChanging(object sender, DetailsViewModeEventArgs e)
    {
        if (e.CancelingEdit == true)
        {
            _presenter.OnCancel();
        }
    }


    #region ISecurityContextDetailsView Members

    public OHE.Security.DataTypes.SecurityContext SecurityContext
    {
        set { this.SecurityContextDataSource.DataSource = value; }
    }

    #endregion
}
