﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Collections.Generic;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using OHE.Security.DataTypes;

public partial class Security_EditSecurityContextForm : System.Web.UI.UserControl
{
    private object _dataItem = null;

    public object DataItem
    {
        get
        {
            return this._dataItem;
        }
        set
        {
            this._dataItem = value;
        }
    }

    

    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);
        this.DataBinding += new System.EventHandler(this.SecurityContext_DataBinding);
    }

    protected void SecurityContext_DataBinding(object sender, System.EventArgs e)
    {

    }

    public List<Institution> InstitutionsList
    {
        set
        {
            this.InstitutionDataSource.DataSource = value;
            this.InstitutionDataSource.DataBind();
        }
    }



    public List<SecurityContext> SecurityContextList
    {
        set
        {
            this.SecurityContextDataSource.DataSource = value;
            this.SecurityContextDataSource.DataBind();
        }
    }


    protected void Page_Load(object sender, EventArgs e)
    {
        
            try
            {
                this.SecurityContextList = (List<SecurityContext>)Cache.Get("securityContexts");
                this.InstitutionsList = (List<Institution>)Cache.Get("institutions");
                
                if (DataItem != null && DataItem.ToString().Contains("OHE.Security.DataTypes.Identity"))
                {
                    SecurityContext.SelectedValue = ((OHE.Security.DataTypes.Identity)(DataItem)).SecurityContextId.ToString();
                    Institution.SelectedValue = (((OHE.Security.DataTypes.Identity)(DataItem)).Institution.ID).ToString();
                    ActiveFlag.Checked = ((OHE.Security.DataTypes.Identity)(DataItem)).ActiveStatus;
                    IsLockedOut.Checked = ((OHE.Security.DataTypes.Identity)(DataItem)).IsLockedOut; 
                }
            }
            catch
            {
                this.SecurityContextList = new List<SecurityContext>();
                this.InstitutionsList = new List<Institution>();
            }
        

    }

}
